/*
	Copyright (c) 2004-2006, The Dojo Foundation
	All Rights Reserved.

	Licensed under the Academic Free License version 2.1 or above OR the
	modified BSD license. For more information on Dojo licensing, see:

		http://dojotoolkit.org/community/licensing.shtml
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(typeof dojo=="undefined"){
var dj_global=this;
var dj_currentContext=this;
function dj_undef(_1,_2){
return (typeof (_2||dj_currentContext)[_1]=="undefined");
}
if(dj_undef("djConfig",this)){
var djConfig={};
}
if(dj_undef("dojo",this)){
var dojo={};
}
dojo.global=function(){
return dj_currentContext;
};
dojo.locale=djConfig.locale;
dojo.version={major:0,minor:4,patch:4,flag:"",revision:Number("$Rev: 21543 $".match(/[0-9]+/)[0]),toString:function(){
with(dojo.version){
return major+"."+minor+"."+patch+flag+" ("+revision+")";
}
}};
dojo.evalProp=function(_3,_4,_5){
if((!_4)||(!_3)){
return undefined;
}
if(!dj_undef(_3,_4)){
return _4[_3];
}
return (_5?(_4[_3]={}):undefined);
};
dojo.parseObjPath=function(_6,_7,_8){
var _9=(_7||dojo.global());
var _a=_6.split(".");
var _b=_a.pop();
for(var i=0,l=_a.length;i<l&&_9;i++){
_9=dojo.evalProp(_a[i],_9,_8);
}
return {obj:_9,prop:_b};
};
dojo.evalObjPath=function(_e,_f){
if(typeof _e!="string"){
return dojo.global();
}
if(_e.indexOf(".")==-1){
return dojo.evalProp(_e,dojo.global(),_f);
}
var ref=dojo.parseObjPath(_e,dojo.global(),_f);
if(ref){
return dojo.evalProp(ref.prop,ref.obj,_f);
}
return null;
};
dojo.errorToString=function(_11){
if(!dj_undef("message",_11)){
return _11.message;
}else{
if(!dj_undef("description",_11)){
return _11.description;
}else{
return _11;
}
}
};
dojo.raise=function(_12,_13){
if(_13){
_12=_12+": "+dojo.errorToString(_13);
}else{
_12=dojo.errorToString(_12);
}
try{
if(djConfig.isDebug){
dojo.hostenv.println("FATAL exception raised: "+_12);
}
}
catch(e){
}
throw _13||Error(_12);
};
dojo.debug=function(){
};
dojo.debugShallow=function(obj){
};
dojo.profile={start:function(){
},end:function(){
},stop:function(){
},dump:function(){
}};
function dj_eval(_15){
return dj_global.eval?dj_global.eval(_15):eval(_15);
}
dojo.unimplemented=function(_16,_17){
var _18="'"+_16+"' not implemented";
if(_17!=null){
_18+=" "+_17;
}
dojo.raise(_18);
};
dojo.deprecated=function(_19,_1a,_1b){
var _1c="DEPRECATED: "+_19;
if(_1a){
_1c+=" "+_1a;
}
if(_1b){
_1c+=" -- will be removed in version: "+_1b;
}
dojo.debug(_1c);
};
dojo.render=(function(){
function vscaffold(_1d,_1e){
var tmp={capable:false,support:{builtin:false,plugin:false},prefixes:_1d};
for(var i=0;i<_1e.length;i++){
tmp[_1e[i]]=false;
}
return tmp;
}
return {name:"",ver:dojo.version,os:{win:false,linux:false,osx:false},html:vscaffold(["html"],["ie","opera","khtml","safari","moz"]),svg:vscaffold(["svg"],["corel","adobe","batik"]),vml:vscaffold(["vml"],["ie"]),swf:vscaffold(["Swf","Flash","Mm"],["mm"]),swt:vscaffold(["Swt"],["ibm"])};
})();
dojo.hostenv=(function(){
var _21={isDebug:false,allowQueryConfig:false,baseScriptUri:"",baseRelativePath:"",libraryScriptUri:"",iePreventClobber:false,ieClobberMinimal:true,preventBackButtonFix:true,delayMozLoadingFix:false,searchIds:[],parseWidgets:true};
if(typeof djConfig=="undefined"){
djConfig=_21;
}else{
for(var _22 in _21){
if(typeof djConfig[_22]=="undefined"){
djConfig[_22]=_21[_22];
}
}
}
return {name_:"(unset)",version_:"(unset)",getName:function(){
return this.name_;
},getVersion:function(){
return this.version_;
},getText:function(uri){
dojo.unimplemented("getText","uri="+uri);
}};
})();
dojo.hostenv.getBaseScriptUri=function(){
if(djConfig.baseScriptUri.length){
return djConfig.baseScriptUri;
}
var uri=new String(djConfig.libraryScriptUri||djConfig.baseRelativePath);
if(!uri){
dojo.raise("Nothing returned by getLibraryScriptUri(): "+uri);
}
var _25=uri.lastIndexOf("/");
djConfig.baseScriptUri=djConfig.baseRelativePath;
return djConfig.baseScriptUri;
};
(function(){
var _26={pkgFileName:"__package__",loading_modules_:{},loaded_modules_:{},addedToLoadingCount:[],removedFromLoadingCount:[],inFlightCount:0,modulePrefixes_:{dojo:{name:"dojo",value:"src"}},setModulePrefix:function(_27,_28){
this.modulePrefixes_[_27]={name:_27,value:_28};
},moduleHasPrefix:function(_29){
var mp=this.modulePrefixes_;
return Boolean(mp[_29]&&mp[_29].value);
},getModulePrefix:function(_2b){
if(this.moduleHasPrefix(_2b)){
return this.modulePrefixes_[_2b].value;
}
return _2b;
},getTextStack:[],loadUriStack:[],loadedUris:[],post_load_:false,modulesLoadedListeners:[],unloadListeners:[],loadNotifying:false};
for(var _2c in _26){
dojo.hostenv[_2c]=_26[_2c];
}
})();
dojo.hostenv.loadPath=function(_2d,_2e,cb){
var uri;
if(_2d.charAt(0)=="/"||_2d.match(/^\w+:/)){
uri=_2d;
}else{
uri=this.getBaseScriptUri()+_2d;
}
if(djConfig.cacheBust&&dojo.render.html.capable){
uri+="?"+String(djConfig.cacheBust).replace(/\W+/g,"");
}
try{
return !_2e?this.loadUri(uri,cb):this.loadUriAndCheck(uri,_2e,cb);
}
catch(e){
dojo.debug(e);
return false;
}
};
dojo.hostenv.loadUri=function(uri,cb){
if(this.loadedUris[uri]){
return true;
}
var _33=this.getText(uri,null,true);
if(!_33){
return false;
}
this.loadedUris[uri]=true;
if(cb){
_33="("+_33+")";
}
var _34=dj_eval(_33);
if(cb){
cb(_34);
}
return true;
};
dojo.hostenv.loadUriAndCheck=function(uri,_36,cb){
var ok=true;
try{
ok=this.loadUri(uri,cb);
}
catch(e){
dojo.debug("failed loading ",uri," with error: ",e);
}
return Boolean(ok&&this.findModule(_36,false));
};
dojo.loaded=function(){
};
dojo.unloaded=function(){
};
dojo.hostenv.loaded=function(){
this.loadNotifying=true;
this.post_load_=true;
var mll=this.modulesLoadedListeners;
for(var x=0;x<mll.length;x++){
mll[x]();
}
this.modulesLoadedListeners=[];
this.loadNotifying=false;
dojo.loaded();
};
dojo.hostenv.unloaded=function(){
var mll=this.unloadListeners;
while(mll.length){
(mll.pop())();
}
dojo.unloaded();
};
dojo.addOnLoad=function(obj,_3d){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.modulesLoadedListeners.push(obj);
}else{
if(arguments.length>1){
dh.modulesLoadedListeners.push(function(){
obj[_3d]();
});
}
}
if(dh.post_load_&&dh.inFlightCount==0&&!dh.loadNotifying){
dh.callLoaded();
}
};
dojo.addOnUnload=function(obj,_40){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.unloadListeners.push(obj);
}else{
if(arguments.length>1){
dh.unloadListeners.push(function(){
obj[_40]();
});
}
}
};
dojo.hostenv.modulesLoaded=function(){
if(this.post_load_){
return;
}
if(this.loadUriStack.length==0&&this.getTextStack.length==0){
if(this.inFlightCount>0){
dojo.debug("files still in flight!");
return;
}
dojo.hostenv.callLoaded();
}
};
dojo.hostenv.callLoaded=function(){
if(typeof setTimeout=="object"||(djConfig["useXDomain"]&&dojo.render.html.opera)){
setTimeout("dojo.hostenv.loaded();",0);
}else{
dojo.hostenv.loaded();
}
};
dojo.hostenv.getModuleSymbols=function(_42){
var _43=_42.split(".");
for(var i=_43.length;i>0;i--){
var _45=_43.slice(0,i).join(".");
if((i==1)&&!this.moduleHasPrefix(_45)){
_43[0]="../"+_43[0];
}else{
var _46=this.getModulePrefix(_45);
if(_46!=_45){
_43.splice(0,i,_46);
break;
}
}
}
return _43;
};
dojo.hostenv._global_omit_module_check=false;
dojo.hostenv.loadModule=function(_47,_48,_49){
if(!_47){
return;
}
_49=this._global_omit_module_check||_49;
var _4a=this.findModule(_47,false);
if(_4a){
return _4a;
}
if(dj_undef(_47,this.loading_modules_)){
this.addedToLoadingCount.push(_47);
}
this.loading_modules_[_47]=1;
var _4b=_47.replace(/\./g,"/")+".js";
var _4c=_47.split(".");
var _4d=this.getModuleSymbols(_47);
var _4e=((_4d[0].charAt(0)!="/")&&!_4d[0].match(/^\w+:/));
var _4f=_4d[_4d.length-1];
var ok;
if(_4f=="*"){
_47=_4c.slice(0,-1).join(".");
while(_4d.length){
_4d.pop();
_4d.push(this.pkgFileName);
_4b=_4d.join("/")+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,!_49?_47:null);
if(ok){
break;
}
_4d.pop();
}
}else{
_4b=_4d.join("/")+".js";
_47=_4c.join(".");
var _51=!_49?_47:null;
ok=this.loadPath(_4b,_51);
if(!ok&&!_48){
_4d.pop();
while(_4d.length){
_4b=_4d.join("/")+".js";
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
_4d.pop();
_4b=_4d.join("/")+"/"+this.pkgFileName+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
}
}
if(!ok&&!_49){
dojo.raise("Could not load '"+_47+"'; last tried '"+_4b+"'");
}
}
if(!_49&&!this["isXDomain"]){
_4a=this.findModule(_47,false);
if(!_4a){
dojo.raise("symbol '"+_47+"' is not defined after loading '"+_4b+"'");
}
}
return _4a;
};
dojo.hostenv.startPackage=function(_52){
var _53=String(_52);
var _54=_53;
var _55=_52.split(/\./);
if(_55[_55.length-1]=="*"){
_55.pop();
_54=_55.join(".");
}
var _56=dojo.evalObjPath(_54,true);
this.loaded_modules_[_53]=_56;
this.loaded_modules_[_54]=_56;
return _56;
};
dojo.hostenv.findModule=function(_57,_58){
var lmn=String(_57);
if(this.loaded_modules_[lmn]){
return this.loaded_modules_[lmn];
}
if(_58){
dojo.raise("no loaded module named '"+_57+"'");
}
return null;
};
dojo.kwCompoundRequire=function(_5a){
var _5b=_5a["common"]||[];
var _5c=_5a[dojo.hostenv.name_]?_5b.concat(_5a[dojo.hostenv.name_]||[]):_5b.concat(_5a["default"]||[]);
for(var x=0;x<_5c.length;x++){
var _5e=_5c[x];
if(_5e.constructor==Array){
dojo.hostenv.loadModule.apply(dojo.hostenv,_5e);
}else{
dojo.hostenv.loadModule(_5e);
}
}
};
dojo.require=function(_5f){
dojo.hostenv.loadModule.apply(dojo.hostenv,arguments);
};
dojo.requireIf=function(_60,_61){
var _62=arguments[0];
if((_62===true)||(_62=="common")||(_62&&dojo.render[_62].capable)){
var _63=[];
for(var i=1;i<arguments.length;i++){
_63.push(arguments[i]);
}
dojo.require.apply(dojo,_63);
}
};
dojo.requireAfterIf=dojo.requireIf;
dojo.provide=function(_65){
return dojo.hostenv.startPackage.apply(dojo.hostenv,arguments);
};
dojo.registerModulePath=function(_66,_67){
return dojo.hostenv.setModulePrefix(_66,_67);
};
if(djConfig["modulePaths"]){
for(var param in djConfig["modulePaths"]){
dojo.registerModulePath(param,djConfig["modulePaths"][param]);
}
}
dojo.setModulePrefix=function(_68,_69){
dojo.deprecated("dojo.setModulePrefix(\""+_68+"\", \""+_69+"\")","replaced by dojo.registerModulePath","0.5");
return dojo.registerModulePath(_68,_69);
};
dojo.exists=function(obj,_6b){
var p=_6b.split(".");
for(var i=0;i<p.length;i++){
if(!obj[p[i]]){
return false;
}
obj=obj[p[i]];
}
return true;
};
dojo.hostenv.normalizeLocale=function(_6e){
var _6f=_6e?_6e.toLowerCase():dojo.locale;
if(_6f=="root"){
_6f="ROOT";
}
return _6f;
};
dojo.hostenv.searchLocalePath=function(_70,_71,_72){
_70=dojo.hostenv.normalizeLocale(_70);
var _73=_70.split("-");
var _74=[];
for(var i=_73.length;i>0;i--){
_74.push(_73.slice(0,i).join("-"));
}
_74.push(false);
if(_71){
_74.reverse();
}
for(var j=_74.length-1;j>=0;j--){
var loc=_74[j]||"ROOT";
var _78=_72(loc);
if(_78){
break;
}
}
};
dojo.hostenv.localesGenerated;
dojo.hostenv.registerNlsPrefix=function(){
dojo.registerModulePath("nls","nls");
};
dojo.hostenv.preloadLocalizations=function(){
if(dojo.hostenv.localesGenerated){
dojo.hostenv.registerNlsPrefix();
function preload(_79){
_79=dojo.hostenv.normalizeLocale(_79);
dojo.hostenv.searchLocalePath(_79,true,function(loc){
for(var i=0;i<dojo.hostenv.localesGenerated.length;i++){
if(dojo.hostenv.localesGenerated[i]==loc){
dojo["require"]("nls.dojo_"+loc);
return true;
}
}
return false;
});
}
preload();
var _7c=djConfig.extraLocale||[];
for(var i=0;i<_7c.length;i++){
preload(_7c[i]);
}
}
dojo.hostenv.preloadLocalizations=function(){
};
};
dojo.requireLocalization=function(_7e,_7f,_80,_81){
dojo.hostenv.preloadLocalizations();
var _82=dojo.hostenv.normalizeLocale(_80);
var _83=[_7e,"nls",_7f].join(".");
var _84="";
if(_81){
var _85=_81.split(",");
for(var i=0;i<_85.length;i++){
if(_82.indexOf(_85[i])==0){
if(_85[i].length>_84.length){
_84=_85[i];
}
}
}
if(!_84){
_84="ROOT";
}
}
var _87=_81?_84:_82;
var _88=dojo.hostenv.findModule(_83);
var _89=null;
if(_88){
if(djConfig.localizationComplete&&_88._built){
return;
}
var _8a=_87.replace("-","_");
var _8b=_83+"."+_8a;
_89=dojo.hostenv.findModule(_8b);
}
if(!_89){
_88=dojo.hostenv.startPackage(_83);
var _8c=dojo.hostenv.getModuleSymbols(_7e);
var _8d=_8c.concat("nls").join("/");
var _8e;
dojo.hostenv.searchLocalePath(_87,_81,function(loc){
var _90=loc.replace("-","_");
var _91=_83+"."+_90;
var _92=false;
if(!dojo.hostenv.findModule(_91)){
dojo.hostenv.startPackage(_91);
var _93=[_8d];
if(loc!="ROOT"){
_93.push(loc);
}
_93.push(_7f);
var _94=_93.join("/")+".js";
_92=dojo.hostenv.loadPath(_94,null,function(_95){
var _96=function(){
};
_96.prototype=_8e;
_88[_90]=new _96();
for(var j in _95){
_88[_90][j]=_95[j];
}
});
}else{
_92=true;
}
if(_92&&_88[_90]){
_8e=_88[_90];
}else{
_88[_90]=_8e;
}
if(_81){
return true;
}
});
}
if(_81&&_82!=_84){
_88[_82.replace("-","_")]=_88[_84.replace("-","_")];
}
};
(function(){
var _98=djConfig.extraLocale;
if(_98){
if(!_98 instanceof Array){
_98=[_98];
}
var req=dojo.requireLocalization;
dojo.requireLocalization=function(m,b,_9c,_9d){
req(m,b,_9c,_9d);
if(_9c){
return;
}
for(var i=0;i<_98.length;i++){
req(m,b,_98[i],_9d);
}
};
}
})();
}
if(typeof window!="undefined"){
(function(){
if(djConfig.allowQueryConfig){
var _9f=document.location.toString();
var _a0=_9f.split("?",2);
if(_a0.length>1){
var _a1=_a0[1];
var _a2=_a1.split("&");
for(var x in _a2){
var sp=_a2[x].split("=");
if((sp[0].length>9)&&(sp[0].substr(0,9)=="djConfig.")){
var opt=sp[0].substr(9);
try{
djConfig[opt]=eval(sp[1]);
}
catch(e){
djConfig[opt]=sp[1];
}
}
}
}
}
if(((djConfig["baseScriptUri"]=="")||(djConfig["baseRelativePath"]==""))&&(document&&document.getElementsByTagName)){
var _a6=document.getElementsByTagName("script");
var _a7=/(__package__|dojo|bootstrap1)\.js([\?\.]|$)/i;
for(var i=0;i<_a6.length;i++){
var src=_a6[i].getAttribute("src");
if(!src){
continue;
}
var m=src.match(_a7);
if(m){
var _ab=src.substring(0,m.index);
if(src.indexOf("bootstrap1")>-1){
_ab+="../";
}
if(!this["djConfig"]){
djConfig={};
}
if(djConfig["baseScriptUri"]==""){
djConfig["baseScriptUri"]=_ab;
}
if(djConfig["baseRelativePath"]==""){
djConfig["baseRelativePath"]=_ab;
}
break;
}
}
}
var dr=dojo.render;
var drh=dojo.render.html;
var drs=dojo.render.svg;
var dua=(drh.UA=navigator.userAgent);
var dav=(drh.AV=navigator.appVersion);
var t=true;
var f=false;
drh.capable=t;
drh.support.builtin=t;
dr.ver=parseFloat(drh.AV);
dr.os.mac=dav.indexOf("Macintosh")>=0;
dr.os.win=dav.indexOf("Windows")>=0;
dr.os.linux=dav.indexOf("X11")>=0;
drh.opera=dua.indexOf("Opera")>=0;
drh.khtml=(dav.indexOf("Konqueror")>=0)||(dav.indexOf("Safari")>=0);
drh.safari=dav.indexOf("Safari")>=0;
var _b3=dua.indexOf("Gecko");
drh.mozilla=drh.moz=(_b3>=0)&&(!drh.khtml);
if(drh.mozilla){
drh.geckoVersion=dua.substring(_b3+6,_b3+14);
}
drh.ie=(document.all)&&(!drh.opera);
drh.ie50=drh.ie&&dav.indexOf("MSIE 5.0")>=0;
drh.ie55=drh.ie&&dav.indexOf("MSIE 5.5")>=0;
drh.ie60=drh.ie&&dav.indexOf("MSIE 6.0")>=0;
drh.ie70=drh.ie&&dav.indexOf("MSIE 7.0")>=0;
var cm=document["compatMode"];
drh.quirks=(cm=="BackCompat")||(cm=="QuirksMode")||drh.ie55||drh.ie50;
dojo.locale=dojo.locale||(drh.ie?navigator.userLanguage:navigator.language).toLowerCase();
dr.vml.capable=drh.ie;
drs.capable=f;
drs.support.plugin=f;
drs.support.builtin=f;
var _b5=window["document"];
var tdi=_b5["implementation"];
if(drh.ie&&(window.location.protocol=="file:")){
djConfig.ieForceActiveXXhr=true;
}
if((tdi)&&(tdi["hasFeature"])&&(tdi.hasFeature("org.w3c.dom.svg","1.0"))){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
if(drh.safari){
var tmp=dua.split("AppleWebKit/")[1];
var ver=parseFloat(tmp.split(" ")[0]);
if(ver>=420){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
}else{
}
})();
dojo.hostenv.startPackage("dojo.hostenv");
dojo.render.name=dojo.hostenv.name_="browser";
dojo.hostenv.searchIds=[];
dojo.hostenv._XMLHTTP_PROGIDS=["Msxml2.XMLHTTP","Microsoft.XMLHTTP","Msxml2.XMLHTTP.4.0"];
dojo.hostenv.getXmlhttpObject=function(){
var _b9=null;
var _ba=null;
if(!dojo.render.html.ie||!djConfig.ieForceActiveXXhr){
try{
_b9=new XMLHttpRequest();
}
catch(e){
}
}
if(!_b9){
for(var i=0;i<3;++i){
var _bc=dojo.hostenv._XMLHTTP_PROGIDS[i];
try{
_b9=new ActiveXObject(_bc);
}
catch(e){
_ba=e;
}
if(_b9){
dojo.hostenv._XMLHTTP_PROGIDS=[_bc];
break;
}
}
}
if(!_b9){
return dojo.raise("XMLHTTP not available",_ba);
}
return _b9;
};
dojo.hostenv._blockAsync=false;
dojo.hostenv.getText=function(uri,_be,_bf){
if(!_be){
this._blockAsync=true;
}
var _c0=this.getXmlhttpObject();
function isDocumentOk(_c1){
var _c2=_c1["status"];
return Boolean((!_c2)||((200<=_c2)&&(300>_c2))||(_c2==304));
}
if(_be){
var _c3=this,_c4=null,gbl=dojo.global();
var xhr=dojo.evalObjPath("dojo.io.XMLHTTPTransport");
_c0.onreadystatechange=function(){
if(_c4){
gbl.clearTimeout(_c4);
_c4=null;
}
if(_c3._blockAsync||(xhr&&xhr._blockAsync)){
_c4=gbl.setTimeout(function(){
_c0.onreadystatechange.apply(this);
},10);
}else{
if(4==_c0.readyState){
if(isDocumentOk(_c0)){
_be(_c0.responseText);
}
}
}
};
}
_c0.open("GET",uri,_be?true:false);
try{
_c0.send(null);
if(_be){
return null;
}
if(!isDocumentOk(_c0)){
var err=Error("Unable to load "+uri+" status:"+_c0.status);
err.status=_c0.status;
err.responseText=_c0.responseText;
throw err;
}
}
catch(e){
this._blockAsync=false;
if((_bf)&&(!_be)){
return null;
}else{
throw e;
}
}
this._blockAsync=false;
return _c0.responseText;
};
dojo.hostenv.defaultDebugContainerId="dojoDebug";
dojo.hostenv._println_buffer=[];
dojo.hostenv._println_safe=false;
dojo.hostenv.println=function(_c8){
if(!dojo.hostenv._println_safe){
dojo.hostenv._println_buffer.push(_c8);
}else{
try{
var _c9=document.getElementById(djConfig.debugContainerId?djConfig.debugContainerId:dojo.hostenv.defaultDebugContainerId);
if(!_c9){
_c9=dojo.body();
}
var div=document.createElement("div");
div.appendChild(document.createTextNode(_c8));
_c9.appendChild(div);
}
catch(e){
try{
document.write("<div>"+_c8+"</div>");
}
catch(e2){
window.status=_c8;
}
}
}
};
dojo.addOnLoad(function(){
dojo.hostenv._println_safe=true;
while(dojo.hostenv._println_buffer.length>0){
dojo.hostenv.println(dojo.hostenv._println_buffer.shift());
}
});
function dj_addNodeEvtHdlr(_cb,_cc,fp){
var _ce=_cb["on"+_cc]||function(){
};
_cb["on"+_cc]=function(){
fp.apply(_cb,arguments);
_ce.apply(_cb,arguments);
};
return true;
}
dojo.hostenv._djInitFired=false;
function dj_load_init(e){
dojo.hostenv._djInitFired=true;
var _d0=(e&&e.type)?e.type.toLowerCase():"load";
if(arguments.callee.initialized||(_d0!="domcontentloaded"&&_d0!="load")){
return;
}
arguments.callee.initialized=true;
if(typeof (_timer)!="undefined"){
clearInterval(_timer);
delete _timer;
}
var _d1=function(){
if(dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
};
if(dojo.hostenv.inFlightCount==0){
_d1();
dojo.hostenv.modulesLoaded();
}else{
dojo.hostenv.modulesLoadedListeners.unshift(_d1);
}
}
if(document.addEventListener){
if(dojo.render.html.opera||(dojo.render.html.moz&&(djConfig["enableMozDomContentLoaded"]===true))){
document.addEventListener("DOMContentLoaded",dj_load_init,null);
}
window.addEventListener("load",dj_load_init,null);
}
if(dojo.render.html.ie&&dojo.render.os.win){
document.attachEvent("onreadystatechange",function(e){
if(document.readyState=="complete"){
dj_load_init();
}
});
}
if(/(WebKit|khtml)/i.test(navigator.userAgent)){
var _timer=setInterval(function(){
if(/loaded|complete/.test(document.readyState)){
dj_load_init();
}
},10);
}
if(dojo.render.html.ie){
dj_addNodeEvtHdlr(window,"beforeunload",function(){
dojo.hostenv._unloading=true;
window.setTimeout(function(){
dojo.hostenv._unloading=false;
},0);
});
}
dj_addNodeEvtHdlr(window,"unload",function(){
dojo.hostenv.unloaded();
if((!dojo.render.html.ie)||(dojo.render.html.ie&&dojo.hostenv._unloading)){
dojo.hostenv.unloaded();
}
});
dojo.hostenv.makeWidgets=function(){
var _d3=[];
if(djConfig.searchIds&&djConfig.searchIds.length>0){
_d3=_d3.concat(djConfig.searchIds);
}
if(dojo.hostenv.searchIds&&dojo.hostenv.searchIds.length>0){
_d3=_d3.concat(dojo.hostenv.searchIds);
}
if((djConfig.parseWidgets)||(_d3.length>0)){
if(dojo.evalObjPath("dojo.widget.Parse")){
var _d4=new dojo.xml.Parse();
if(_d3.length>0){
for(var x=0;x<_d3.length;x++){
var _d6=document.getElementById(_d3[x]);
if(!_d6){
continue;
}
var _d7=_d4.parseElement(_d6,null,true);
dojo.widget.getParser().createComponents(_d7);
}
}else{
if(djConfig.parseWidgets){
var _d7=_d4.parseElement(dojo.body(),null,true);
dojo.widget.getParser().createComponents(_d7);
}
}
}
}
};
dojo.addOnLoad(function(){
if(!dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
});
try{
if(dojo.render.html.ie){
document.namespaces.add("v","urn:schemas-microsoft-com:vml");
document.createStyleSheet().addRule("v\\:*","behavior:url(#default#VML)");
}
}
catch(e){
}
dojo.hostenv.writeIncludes=function(){
};
if(!dj_undef("document",this)){
dj_currentDocument=this.document;
}
dojo.doc=function(){
return dj_currentDocument;
};
dojo.body=function(){
return dojo.doc().body||dojo.doc().getElementsByTagName("body")[0];
};
dojo.byId=function(id,doc){
if((id)&&((typeof id=="string")||(id instanceof String))){
if(!doc){
doc=dj_currentDocument;
}
var ele=doc.getElementById(id);
if(ele&&(ele.id!=id)&&doc.all){
ele=null;
eles=doc.all[id];
if(eles){
if(eles.length){
for(var i=0;i<eles.length;i++){
if(eles[i].id==id){
ele=eles[i];
break;
}
}
}else{
ele=eles;
}
}
}
return ele;
}
return id;
};
dojo.setContext=function(_dc,_dd){
dj_currentContext=_dc;
dj_currentDocument=_dd;
};
dojo._fireCallback=function(_de,_df,_e0){
if((_df)&&((typeof _de=="string")||(_de instanceof String))){
_de=_df[_de];
}
return (_df?_de.apply(_df,_e0||[]):_de());
};
dojo.withGlobal=function(_e1,_e2,_e3,_e4){
var _e5;
var _e6=dj_currentContext;
var _e7=dj_currentDocument;
try{
dojo.setContext(_e1,_e1.document);
_e5=dojo._fireCallback(_e2,_e3,_e4);
}
finally{
dojo.setContext(_e6,_e7);
}
return _e5;
};
dojo.withDoc=function(_e8,_e9,_ea,_eb){
var _ec;
var _ed=dj_currentDocument;
try{
dj_currentDocument=_e8;
_ec=dojo._fireCallback(_e9,_ea,_eb);
}
finally{
dj_currentDocument=_ed;
}
return _ec;
};
}
dojo.requireIf((djConfig["isDebug"]||djConfig["debugAtAllCosts"]),"dojo.debug");
dojo.requireIf(djConfig["debugAtAllCosts"]&&!window.widget&&!djConfig["useXDomain"],"dojo.browser_debug");
dojo.requireIf(djConfig["debugAtAllCosts"]&&!window.widget&&djConfig["useXDomain"],"dojo.browser_debug_xd");
dojo.provide("dojo.lang.common");
dojo.lang.inherits=function(_ee,_ef){
if(!dojo.lang.isFunction(_ef)){
dojo.raise("dojo.inherits: superclass argument ["+_ef+"] must be a function (subclass: ["+_ee+"']");
}
_ee.prototype=new _ef();
_ee.prototype.constructor=_ee;
_ee.superclass=_ef.prototype;
_ee["super"]=_ef.prototype;
};
dojo.lang._mixin=function(obj,_f1){
var _f2={};
for(var x in _f1){
if((typeof _f2[x]=="undefined")||(_f2[x]!=_f1[x])){
obj[x]=_f1[x];
}
}
if(dojo.render.html.ie&&(typeof (_f1["toString"])=="function")&&(_f1["toString"]!=obj["toString"])&&(_f1["toString"]!=_f2["toString"])){
obj.toString=_f1.toString;
}
return obj;
};
dojo.lang.mixin=function(obj,_f5){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(obj,arguments[i]);
}
return obj;
};
dojo.lang.extend=function(_f8,_f9){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(_f8.prototype,arguments[i]);
}
return _f8;
};
dojo.inherits=dojo.lang.inherits;
dojo.mixin=dojo.lang.mixin;
dojo.extend=dojo.lang.extend;
dojo.lang.find=function(_fc,_fd,_fe,_ff){
if(!dojo.lang.isArrayLike(_fc)&&dojo.lang.isArrayLike(_fd)){
dojo.deprecated("dojo.lang.find(value, array)","use dojo.lang.find(array, value) instead","0.5");
var temp=_fc;
_fc=_fd;
_fd=temp;
}
var _101=dojo.lang.isString(_fc);
if(_101){
_fc=_fc.split("");
}
if(_ff){
var step=-1;
var i=_fc.length-1;
var end=-1;
}else{
var step=1;
var i=0;
var end=_fc.length;
}
if(_fe){
while(i!=end){
if(_fc[i]===_fd){
return i;
}
i+=step;
}
}else{
while(i!=end){
if(_fc[i]==_fd){
return i;
}
i+=step;
}
}
return -1;
};
dojo.lang.indexOf=dojo.lang.find;
dojo.lang.findLast=function(_105,_106,_107){
return dojo.lang.find(_105,_106,_107,true);
};
dojo.lang.lastIndexOf=dojo.lang.findLast;
dojo.lang.inArray=function(_108,_109){
return dojo.lang.find(_108,_109)>-1;
};
dojo.lang.isObject=function(it){
if(typeof it=="undefined"){
return false;
}
return (typeof it=="object"||it===null||dojo.lang.isArray(it)||dojo.lang.isFunction(it));
};
dojo.lang.isArray=function(it){
return (it&&it instanceof Array||typeof it=="array");
};
dojo.lang.isArrayLike=function(it){
if((!it)||(dojo.lang.isUndefined(it))){
return false;
}
if(dojo.lang.isString(it)){
return false;
}
if(dojo.lang.isFunction(it)){
return false;
}
if(dojo.lang.isArray(it)){
return true;
}
if((it.tagName)&&(it.tagName.toLowerCase()=="form")){
return false;
}
if(dojo.lang.isNumber(it.length)&&isFinite(it.length)){
return true;
}
return false;
};
dojo.lang.isFunction=function(it){
return (it instanceof Function||typeof it=="function");
};
(function(){
if((dojo.render.html.capable)&&(dojo.render.html["safari"])){
dojo.lang.isFunction=function(it){
if((typeof (it)=="function")&&(it=="[object NodeList]")){
return false;
}
return (it instanceof Function||typeof it=="function");
};
}
})();
dojo.lang.isString=function(it){
return (typeof it=="string"||it instanceof String);
};
dojo.lang.isAlien=function(it){
if(!it){
return false;
}
return !dojo.lang.isFunction(it)&&/\{\s*\[native code\]\s*\}/.test(String(it));
};
dojo.lang.isBoolean=function(it){
return (it instanceof Boolean||typeof it=="boolean");
};
dojo.lang.isNumber=function(it){
return (it instanceof Number||typeof it=="number");
};
dojo.lang.isUndefined=function(it){
return ((typeof (it)=="undefined")&&(it==undefined));
};
dojo.provide("dojo.lang.array");
dojo.lang.mixin(dojo.lang,{has:function(obj,name){
try{
return typeof obj[name]!="undefined";
}
catch(e){
return false;
}
},isEmpty:function(obj){
if(dojo.lang.isObject(obj)){
var tmp={};
var _118=0;
for(var x in obj){
if(obj[x]&&(!tmp[x])){
_118++;
break;
}
}
return _118==0;
}else{
if(dojo.lang.isArrayLike(obj)||dojo.lang.isString(obj)){
return obj.length==0;
}
}
},map:function(arr,obj,_11c){
var _11d=dojo.lang.isString(arr);
if(_11d){
arr=arr.split("");
}
if(dojo.lang.isFunction(obj)&&(!_11c)){
_11c=obj;
obj=dj_global;
}else{
if(dojo.lang.isFunction(obj)&&_11c){
var _11e=obj;
obj=_11c;
_11c=_11e;
}
}
if(Array.map){
var _11f=Array.map(arr,_11c,obj);
}else{
var _11f=[];
for(var i=0;i<arr.length;++i){
_11f.push(_11c.call(obj,arr[i]));
}
}
if(_11d){
return _11f.join("");
}else{
return _11f;
}
},reduce:function(arr,_122,obj,_124){
var _125=_122;
if(arguments.length==2){
_124=_122;
_125=arr[0];
arr=arr.slice(1);
}else{
if(arguments.length==3){
if(dojo.lang.isFunction(obj)){
_124=obj;
obj=null;
}
}else{
if(dojo.lang.isFunction(obj)){
var tmp=_124;
_124=obj;
obj=tmp;
}
}
}
var ob=obj||dj_global;
dojo.lang.map(arr,function(val){
_125=_124.call(ob,_125,val);
});
return _125;
},forEach:function(_129,_12a,_12b){
if(dojo.lang.isString(_129)){
_129=_129.split("");
}
if(Array.forEach){
Array.forEach(_129,_12a,_12b);
}else{
if(!_12b){
_12b=dj_global;
}
for(var i=0,l=_129.length;i<l;i++){
_12a.call(_12b,_129[i],i,_129);
}
}
},_everyOrSome:function(_12e,arr,_130,_131){
if(dojo.lang.isString(arr)){
arr=arr.split("");
}
if(Array.every){
return Array[_12e?"every":"some"](arr,_130,_131);
}else{
if(!_131){
_131=dj_global;
}
for(var i=0,l=arr.length;i<l;i++){
var _134=_130.call(_131,arr[i],i,arr);
if(_12e&&!_134){
return false;
}else{
if((!_12e)&&(_134)){
return true;
}
}
}
return Boolean(_12e);
}
},every:function(arr,_136,_137){
return this._everyOrSome(true,arr,_136,_137);
},some:function(arr,_139,_13a){
return this._everyOrSome(false,arr,_139,_13a);
},filter:function(arr,_13c,_13d){
var _13e=dojo.lang.isString(arr);
if(_13e){
arr=arr.split("");
}
var _13f;
if(Array.filter){
_13f=Array.filter(arr,_13c,_13d);
}else{
if(!_13d){
if(arguments.length>=3){
dojo.raise("thisObject doesn't exist!");
}
_13d=dj_global;
}
_13f=[];
for(var i=0;i<arr.length;i++){
if(_13c.call(_13d,arr[i],i,arr)){
_13f.push(arr[i]);
}
}
}
if(_13e){
return _13f.join("");
}else{
return _13f;
}
},unnest:function(){
var out=[];
for(var i=0;i<arguments.length;i++){
if(dojo.lang.isArrayLike(arguments[i])){
var add=dojo.lang.unnest.apply(this,arguments[i]);
out=out.concat(add);
}else{
out.push(arguments[i]);
}
}
return out;
},toArray:function(_144,_145){
var _146=[];
for(var i=_145||0;i<_144.length;i++){
_146.push(_144[i]);
}
return _146;
}});
dojo.provide("dojo.lang.extras");
dojo.lang.setTimeout=function(func,_149){
var _14a=window,_14b=2;
if(!dojo.lang.isFunction(func)){
_14a=func;
func=_149;
_149=arguments[2];
_14b++;
}
if(dojo.lang.isString(func)){
func=_14a[func];
}
var args=[];
for(var i=_14b;i<arguments.length;i++){
args.push(arguments[i]);
}
return dojo.global().setTimeout(function(){
func.apply(_14a,args);
},_149);
};
dojo.lang.clearTimeout=function(_14e){
dojo.global().clearTimeout(_14e);
};
dojo.lang.getNameInObj=function(ns,item){
if(!ns){
ns=dj_global;
}
for(var x in ns){
if(ns[x]===item){
return new String(x);
}
}
return null;
};
dojo.lang.shallowCopy=function(obj,deep){
var i,ret;
if(obj===null){
return null;
}
if(dojo.lang.isObject(obj)){
ret=new obj.constructor();
for(i in obj){
if(dojo.lang.isUndefined(ret[i])){
ret[i]=deep?dojo.lang.shallowCopy(obj[i],deep):obj[i];
}
}
}else{
if(dojo.lang.isArray(obj)){
ret=[];
for(i=0;i<obj.length;i++){
ret[i]=deep?dojo.lang.shallowCopy(obj[i],deep):obj[i];
}
}else{
ret=obj;
}
}
return ret;
};
dojo.lang.firstValued=function(){
for(var i=0;i<arguments.length;i++){
if(typeof arguments[i]!="undefined"){
return arguments[i];
}
}
return undefined;
};
dojo.lang.getObjPathValue=function(_157,_158,_159){
with(dojo.parseObjPath(_157,_158,_159)){
return dojo.evalProp(prop,obj,_159);
}
};
dojo.lang.setObjPathValue=function(_15a,_15b,_15c,_15d){
dojo.deprecated("dojo.lang.setObjPathValue","use dojo.parseObjPath and the '=' operator","0.6");
if(arguments.length<4){
_15d=true;
}
with(dojo.parseObjPath(_15a,_15c,_15d)){
if(obj&&(_15d||(prop in obj))){
obj[prop]=_15b;
}
}
};
dojo.provide("dojo.lang.declare");
dojo.lang.declare=function(_15e,_15f,init,_161){
if((dojo.lang.isFunction(_161))||((!_161)&&(!dojo.lang.isFunction(init)))){
var temp=_161;
_161=init;
init=temp;
}
var _163=[];
if(dojo.lang.isArray(_15f)){
_163=_15f;
_15f=_163.shift();
}
if(!init){
init=dojo.evalObjPath(_15e,false);
if((init)&&(!dojo.lang.isFunction(init))){
init=null;
}
}
var ctor=dojo.lang.declare._makeConstructor();
var scp=(_15f?_15f.prototype:null);
if(scp){
scp.prototyping=true;
ctor.prototype=new _15f();
scp.prototyping=false;
}
ctor.superclass=scp;
ctor.mixins=_163;
for(var i=0,l=_163.length;i<l;i++){
dojo.lang.extend(ctor,_163[i].prototype);
}
ctor.prototype.initializer=null;
ctor.prototype.declaredClass=_15e;
if(dojo.lang.isArray(_161)){
dojo.lang.extend.apply(dojo.lang,[ctor].concat(_161));
}else{
dojo.lang.extend(ctor,(_161)||{});
}
dojo.lang.extend(ctor,dojo.lang.declare._common);
ctor.prototype.constructor=ctor;
ctor.prototype.initializer=(ctor.prototype.initializer)||(init)||(function(){
});
var _168=dojo.parseObjPath(_15e,null,true);
_168.obj[_168.prop]=ctor;
return ctor;
};
dojo.lang.declare._makeConstructor=function(){
return function(){
var self=this._getPropContext();
var s=self.constructor.superclass;
if((s)&&(s.constructor)){
if(s.constructor==arguments.callee){
this._inherited("constructor",arguments);
}else{
this._contextMethod(s,"constructor",arguments);
}
}
var ms=(self.constructor.mixins)||([]);
for(var i=0,m;(m=ms[i]);i++){
(((m.prototype)&&(m.prototype.initializer))||(m)).apply(this,arguments);
}
if((!this.prototyping)&&(self.initializer)){
self.initializer.apply(this,arguments);
}
};
};
dojo.lang.declare._common={_getPropContext:function(){
return (this.___proto||this);
},_contextMethod:function(_16e,_16f,args){
var _171,_172=this.___proto;
this.___proto=_16e;
try{
_171=_16e[_16f].apply(this,(args||[]));
}
catch(e){
throw e;
}
finally{
this.___proto=_172;
}
return _171;
},_inherited:function(prop,args){
var p=this._getPropContext();
do{
if((!p.constructor)||(!p.constructor.superclass)){
return;
}
p=p.constructor.superclass;
}while(!(prop in p));
return (dojo.lang.isFunction(p[prop])?this._contextMethod(p,prop,args):p[prop]);
},inherited:function(prop,args){
dojo.deprecated("'inherited' method is dangerous, do not up-call! 'inherited' is slated for removal in 0.5; name your super class (or use superclass property) instead.","0.5");
this._inherited(prop,args);
}};
dojo.declare=dojo.lang.declare;
dojo.provide("dojo.lang.func");
dojo.lang.hitch=function(_178,_179){
var args=[];
for(var x=2;x<arguments.length;x++){
args.push(arguments[x]);
}
var fcn=(dojo.lang.isString(_179)?_178[_179]:_179)||function(){
};
return function(){
var ta=args.concat([]);
for(var x=0;x<arguments.length;x++){
ta.push(arguments[x]);
}
return fcn.apply(_178,ta);
};
};
dojo.lang.anonCtr=0;
dojo.lang.anon={};
dojo.lang.nameAnonFunc=function(_17f,_180,_181){
var nso=(_180||dojo.lang.anon);
if((_181)||((dj_global["djConfig"])&&(djConfig["slowAnonFuncLookups"]==true))){
for(var x in nso){
try{
if(nso[x]===_17f){
return x;
}
}
catch(e){
}
}
}
var ret="__"+dojo.lang.anonCtr++;
while(typeof nso[ret]!="undefined"){
ret="__"+dojo.lang.anonCtr++;
}
nso[ret]=_17f;
return ret;
};
dojo.lang.forward=function(_185){
return function(){
return this[_185].apply(this,arguments);
};
};
dojo.lang.curry=function(_186,func){
var _188=[];
_186=_186||dj_global;
if(dojo.lang.isString(func)){
func=_186[func];
}
for(var x=2;x<arguments.length;x++){
_188.push(arguments[x]);
}
var _18a=(func["__preJoinArity"]||func.length)-_188.length;
function gather(_18b,_18c,_18d){
var _18e=_18d;
var _18f=_18c.slice(0);
for(var x=0;x<_18b.length;x++){
_18f.push(_18b[x]);
}
_18d=_18d-_18b.length;
if(_18d<=0){
var res=func.apply(_186,_18f);
_18d=_18e;
return res;
}else{
return function(){
return gather(arguments,_18f,_18d);
};
}
}
return gather([],_188,_18a);
};
dojo.lang.curryArguments=function(_192,func,args,_195){
var _196=[];
var x=_195||0;
for(x=_195;x<args.length;x++){
_196.push(args[x]);
}
return dojo.lang.curry.apply(dojo.lang,[_192,func].concat(_196));
};
dojo.lang.tryThese=function(){
for(var x=0;x<arguments.length;x++){
try{
if(typeof arguments[x]=="function"){
var ret=(arguments[x]());
if(ret){
return ret;
}
}
}
catch(e){
dojo.debug(e);
}
}
};
dojo.lang.delayThese=function(farr,cb,_19c,_19d){
if(!farr.length){
if(typeof _19d=="function"){
_19d();
}
return;
}
if((typeof _19c=="undefined")&&(typeof cb=="number")){
_19c=cb;
cb=function(){
};
}else{
if(!cb){
cb=function(){
};
if(!_19c){
_19c=0;
}
}
}
setTimeout(function(){
(farr.shift())();
cb();
dojo.lang.delayThese(farr,cb,_19c,_19d);
},_19c);
};
dojo.provide("dojo.event.common");
dojo.event=new function(){
this._canTimeout=dojo.lang.isFunction(dj_global["setTimeout"])||dojo.lang.isAlien(dj_global["setTimeout"]);
function interpolateArgs(args,_19f){
var dl=dojo.lang;
var ao={srcObj:dj_global,srcFunc:null,adviceObj:dj_global,adviceFunc:null,aroundObj:null,aroundFunc:null,adviceType:(args.length>2)?args[0]:"after",precedence:"last",once:false,delay:null,rate:0,adviceMsg:false,maxCalls:-1};
switch(args.length){
case 0:
return;
case 1:
return;
case 2:
ao.srcFunc=args[0];
ao.adviceFunc=args[1];
break;
case 3:
if((dl.isObject(args[0]))&&(dl.isString(args[1]))&&(dl.isString(args[2]))){
ao.adviceType="after";
ao.srcObj=args[0];
ao.srcFunc=args[1];
ao.adviceFunc=args[2];
}else{
if((dl.isString(args[1]))&&(dl.isString(args[2]))){
ao.srcFunc=args[1];
ao.adviceFunc=args[2];
}else{
if((dl.isObject(args[0]))&&(dl.isString(args[1]))&&(dl.isFunction(args[2]))){
ao.adviceType="after";
ao.srcObj=args[0];
ao.srcFunc=args[1];
var _1a2=dl.nameAnonFunc(args[2],ao.adviceObj,_19f);
ao.adviceFunc=_1a2;
}else{
if((dl.isFunction(args[0]))&&(dl.isObject(args[1]))&&(dl.isString(args[2]))){
ao.adviceType="after";
ao.srcObj=dj_global;
var _1a2=dl.nameAnonFunc(args[0],ao.srcObj,_19f);
ao.srcFunc=_1a2;
ao.adviceObj=args[1];
ao.adviceFunc=args[2];
}
}
}
}
break;
case 4:
if((dl.isObject(args[0]))&&(dl.isObject(args[2]))){
ao.adviceType="after";
ao.srcObj=args[0];
ao.srcFunc=args[1];
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
if((dl.isString(args[0]))&&(dl.isString(args[1]))&&(dl.isObject(args[2]))){
ao.adviceType=args[0];
ao.srcObj=dj_global;
ao.srcFunc=args[1];
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
if((dl.isString(args[0]))&&(dl.isFunction(args[1]))&&(dl.isObject(args[2]))){
ao.adviceType=args[0];
ao.srcObj=dj_global;
var _1a2=dl.nameAnonFunc(args[1],dj_global,_19f);
ao.srcFunc=_1a2;
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
if((dl.isString(args[0]))&&(dl.isObject(args[1]))&&(dl.isString(args[2]))&&(dl.isFunction(args[3]))){
ao.srcObj=args[1];
ao.srcFunc=args[2];
var _1a2=dl.nameAnonFunc(args[3],dj_global,_19f);
ao.adviceObj=dj_global;
ao.adviceFunc=_1a2;
}else{
if(dl.isObject(args[1])){
ao.srcObj=args[1];
ao.srcFunc=args[2];
ao.adviceObj=dj_global;
ao.adviceFunc=args[3];
}else{
if(dl.isObject(args[2])){
ao.srcObj=dj_global;
ao.srcFunc=args[1];
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
ao.srcObj=ao.adviceObj=ao.aroundObj=dj_global;
ao.srcFunc=args[1];
ao.adviceFunc=args[2];
ao.aroundFunc=args[3];
}
}
}
}
}
}
break;
case 6:
ao.srcObj=args[1];
ao.srcFunc=args[2];
ao.adviceObj=args[3];
ao.adviceFunc=args[4];
ao.aroundFunc=args[5];
ao.aroundObj=dj_global;
break;
default:
ao.srcObj=args[1];
ao.srcFunc=args[2];
ao.adviceObj=args[3];
ao.adviceFunc=args[4];
ao.aroundObj=args[5];
ao.aroundFunc=args[6];
ao.once=args[7];
ao.delay=args[8];
ao.rate=args[9];
ao.adviceMsg=args[10];
ao.maxCalls=(!isNaN(parseInt(args[11])))?args[11]:-1;
break;
}
if(dl.isFunction(ao.aroundFunc)){
var _1a2=dl.nameAnonFunc(ao.aroundFunc,ao.aroundObj,_19f);
ao.aroundFunc=_1a2;
}
if(dl.isFunction(ao.srcFunc)){
ao.srcFunc=dl.getNameInObj(ao.srcObj,ao.srcFunc);
}
if(dl.isFunction(ao.adviceFunc)){
ao.adviceFunc=dl.getNameInObj(ao.adviceObj,ao.adviceFunc);
}
if((ao.aroundObj)&&(dl.isFunction(ao.aroundFunc))){
ao.aroundFunc=dl.getNameInObj(ao.aroundObj,ao.aroundFunc);
}
if(!ao.srcObj){
dojo.raise("bad srcObj for srcFunc: "+ao.srcFunc);
}
if(!ao.adviceObj){
dojo.raise("bad adviceObj for adviceFunc: "+ao.adviceFunc);
}
if(!ao.adviceFunc){
dojo.debug("bad adviceFunc for srcFunc: "+ao.srcFunc);
dojo.debugShallow(ao);
}
return ao;
}
this.connect=function(){
if(arguments.length==1){
var ao=arguments[0];
}else{
var ao=interpolateArgs(arguments,true);
}
if(dojo.lang.isString(ao.srcFunc)&&(ao.srcFunc.toLowerCase()=="onkey")){
if(dojo.render.html.ie){
ao.srcFunc="onkeydown";
this.connect(ao);
}
ao.srcFunc="onkeypress";
}
if(dojo.lang.isArray(ao.srcObj)&&ao.srcObj!=""){
var _1a4={};
for(var x in ao){
_1a4[x]=ao[x];
}
var mjps=[];
dojo.lang.forEach(ao.srcObj,function(src){
if((dojo.render.html.capable)&&(dojo.lang.isString(src))){
src=dojo.byId(src);
}
_1a4.srcObj=src;
mjps.push(dojo.event.connect.call(dojo.event,_1a4));
});
return mjps;
}
var mjp=dojo.event.MethodJoinPoint.getForMethod(ao.srcObj,ao.srcFunc);
if(ao.adviceFunc){
var mjp2=dojo.event.MethodJoinPoint.getForMethod(ao.adviceObj,ao.adviceFunc);
}
mjp.kwAddAdvice(ao);
return mjp;
};
this.log=function(a1,a2){
var _1ac;
if((arguments.length==1)&&(typeof a1=="object")){
_1ac=a1;
}else{
_1ac={srcObj:a1,srcFunc:a2};
}
_1ac.adviceFunc=function(){
var _1ad=[];
for(var x=0;x<arguments.length;x++){
_1ad.push(arguments[x]);
}
dojo.debug("("+_1ac.srcObj+")."+_1ac.srcFunc,":",_1ad.join(", "));
};
this.kwConnect(_1ac);
};
this.connectBefore=function(){
var args=["before"];
for(var i=0;i<arguments.length;i++){
args.push(arguments[i]);
}
return this.connect.apply(this,args);
};
this.connectAround=function(){
var args=["around"];
for(var i=0;i<arguments.length;i++){
args.push(arguments[i]);
}
return this.connect.apply(this,args);
};
this.connectOnce=function(){
var ao=interpolateArgs(arguments,true);
ao.once=true;
return this.connect(ao);
};
this.connectRunOnce=function(){
var ao=interpolateArgs(arguments,true);
ao.maxCalls=1;
return this.connect(ao);
};
this._kwConnectImpl=function(_1b5,_1b6){
var fn=(_1b6)?"disconnect":"connect";
if(typeof _1b5["srcFunc"]=="function"){
_1b5.srcObj=_1b5["srcObj"]||dj_global;
var _1b8=dojo.lang.nameAnonFunc(_1b5.srcFunc,_1b5.srcObj,true);
_1b5.srcFunc=_1b8;
}
if(typeof _1b5["adviceFunc"]=="function"){
_1b5.adviceObj=_1b5["adviceObj"]||dj_global;
var _1b8=dojo.lang.nameAnonFunc(_1b5.adviceFunc,_1b5.adviceObj,true);
_1b5.adviceFunc=_1b8;
}
_1b5.srcObj=_1b5["srcObj"]||dj_global;
_1b5.adviceObj=_1b5["adviceObj"]||_1b5["targetObj"]||dj_global;
_1b5.adviceFunc=_1b5["adviceFunc"]||_1b5["targetFunc"];
return dojo.event[fn](_1b5);
};
this.kwConnect=function(_1b9){
return this._kwConnectImpl(_1b9,false);
};
this.disconnect=function(){
if(arguments.length==1){
var ao=arguments[0];
}else{
var ao=interpolateArgs(arguments,true);
}
if(!ao.adviceFunc){
return;
}
if(dojo.lang.isString(ao.srcFunc)&&(ao.srcFunc.toLowerCase()=="onkey")){
if(dojo.render.html.ie){
ao.srcFunc="onkeydown";
this.disconnect(ao);
}
ao.srcFunc="onkeypress";
}
if(!ao.srcObj[ao.srcFunc]){
return null;
}
var mjp=dojo.event.MethodJoinPoint.getForMethod(ao.srcObj,ao.srcFunc,true);
mjp.removeAdvice(ao.adviceObj,ao.adviceFunc,ao.adviceType,ao.once);
return mjp;
};
this.kwDisconnect=function(_1bc){
return this._kwConnectImpl(_1bc,true);
};
};
dojo.event.MethodInvocation=function(_1bd,obj,args){
this.jp_=_1bd;
this.object=obj;
this.args=[];
for(var x=0;x<args.length;x++){
this.args[x]=args[x];
}
this.around_index=-1;
};
dojo.event.MethodInvocation.prototype.proceed=function(){
this.around_index++;
if(this.around_index>=this.jp_.around.length){
return this.jp_.object[this.jp_.methodname].apply(this.jp_.object,this.args);
}else{
var ti=this.jp_.around[this.around_index];
var mobj=ti[0]||dj_global;
var meth=ti[1];
return mobj[meth].call(mobj,this);
}
};
dojo.event.MethodJoinPoint=function(obj,_1c5){
this.object=obj||dj_global;
this.methodname=_1c5;
this.methodfunc=this.object[_1c5];
this.squelch=false;
};
dojo.event.MethodJoinPoint.getForMethod=function(obj,_1c7){
if(!obj){
obj=dj_global;
}
var ofn=obj[_1c7];
if(!ofn){
ofn=obj[_1c7]=function(){
};
if(!obj[_1c7]){
dojo.raise("Cannot set do-nothing method on that object "+_1c7);
}
}else{
if((typeof ofn!="function")&&(!dojo.lang.isFunction(ofn))&&(!dojo.lang.isAlien(ofn))){
return null;
}
}
var _1c9=_1c7+"$joinpoint";
var _1ca=_1c7+"$joinpoint$method";
var _1cb=obj[_1c9];
if(!_1cb){
var _1cc=false;
if(dojo.event["browser"]){
if((obj["attachEvent"])||(obj["nodeType"])||(obj["addEventListener"])){
_1cc=true;
dojo.event.browser.addClobberNodeAttrs(obj,[_1c9,_1ca,_1c7]);
}
}
var _1cd=ofn.length;
obj[_1ca]=ofn;
_1cb=obj[_1c9]=new dojo.event.MethodJoinPoint(obj,_1ca);
if(!_1cc){
obj[_1c7]=function(){
return _1cb.run.apply(_1cb,arguments);
};
}else{
obj[_1c7]=function(){
var args=[];
if(!arguments.length){
var evt=null;
try{
if(obj.ownerDocument){
evt=obj.ownerDocument.parentWindow.event;
}else{
if(obj.documentElement){
evt=obj.documentElement.ownerDocument.parentWindow.event;
}else{
if(obj.event){
evt=obj.event;
}else{
evt=window.event;
}
}
}
}
catch(e){
evt=window.event;
}
if(evt){
args.push(dojo.event.browser.fixEvent(evt,this));
}
}else{
for(var x=0;x<arguments.length;x++){
if((x==0)&&(dojo.event.browser.isEvent(arguments[x]))){
args.push(dojo.event.browser.fixEvent(arguments[x],this));
}else{
args.push(arguments[x]);
}
}
}
return _1cb.run.apply(_1cb,args);
};
}
obj[_1c7].__preJoinArity=_1cd;
}
return _1cb;
};
dojo.lang.extend(dojo.event.MethodJoinPoint,{squelch:false,unintercept:function(){
this.object[this.methodname]=this.methodfunc;
this.before=[];
this.after=[];
this.around=[];
},disconnect:dojo.lang.forward("unintercept"),run:function(){
var obj=this.object||dj_global;
var args=arguments;
var _1d3=[];
for(var x=0;x<args.length;x++){
_1d3[x]=args[x];
}
var _1d5=function(marr){
if(!marr){
dojo.debug("Null argument to unrollAdvice()");
return;
}
var _1d7=marr[0]||dj_global;
var _1d8=marr[1];
if(!_1d7[_1d8]){
dojo.raise("function \""+_1d8+"\" does not exist on \""+_1d7+"\"");
}
var _1d9=marr[2]||dj_global;
var _1da=marr[3];
var msg=marr[6];
var _1dc=marr[7];
if(_1dc>-1){
if(_1dc==0){
return;
}
marr[7]--;
}
var _1dd;
var to={args:[],jp_:this,object:obj,proceed:function(){
return _1d7[_1d8].apply(_1d7,to.args);
}};
to.args=_1d3;
var _1df=parseInt(marr[4]);
var _1e0=((!isNaN(_1df))&&(marr[4]!==null)&&(typeof marr[4]!="undefined"));
if(marr[5]){
var rate=parseInt(marr[5]);
var cur=new Date();
var _1e3=false;
if((marr["last"])&&((cur-marr.last)<=rate)){
if(dojo.event._canTimeout){
if(marr["delayTimer"]){
clearTimeout(marr.delayTimer);
}
var tod=parseInt(rate*2);
var mcpy=dojo.lang.shallowCopy(marr);
marr.delayTimer=setTimeout(function(){
mcpy[5]=0;
_1d5(mcpy);
},tod);
}
return;
}else{
marr.last=cur;
}
}
if(_1da){
_1d9[_1da].call(_1d9,to);
}else{
if((_1e0)&&((dojo.render.html)||(dojo.render.svg))){
dj_global["setTimeout"](function(){
if(msg){
_1d7[_1d8].call(_1d7,to);
}else{
_1d7[_1d8].apply(_1d7,args);
}
},_1df);
}else{
if(msg){
_1d7[_1d8].call(_1d7,to);
}else{
_1d7[_1d8].apply(_1d7,args);
}
}
}
};
var _1e6=function(){
if(this.squelch){
try{
return _1d5.apply(this,arguments);
}
catch(e){
dojo.debug(e);
}
}else{
return _1d5.apply(this,arguments);
}
};
if((this["before"])&&(this.before.length>0)){
dojo.lang.forEach(this.before.concat(new Array()),_1e6);
}
var _1e7;
try{
if((this["around"])&&(this.around.length>0)){
var mi=new dojo.event.MethodInvocation(this,obj,args);
_1e7=mi.proceed();
}else{
if(this.methodfunc){
_1e7=this.object[this.methodname].apply(this.object,args);
}
}
}
catch(e){
if(!this.squelch){
dojo.debug(e,"when calling",this.methodname,"on",this.object,"with arguments",args);
dojo.raise(e);
}
}
if((this["after"])&&(this.after.length>0)){
dojo.lang.forEach(this.after.concat(new Array()),_1e6);
}
return (this.methodfunc)?_1e7:null;
},getArr:function(kind){
var type="after";
if((typeof kind=="string")&&(kind.indexOf("before")!=-1)){
type="before";
}else{
if(kind=="around"){
type="around";
}
}
if(!this[type]){
this[type]=[];
}
return this[type];
},kwAddAdvice:function(args){
this.addAdvice(args["adviceObj"],args["adviceFunc"],args["aroundObj"],args["aroundFunc"],args["adviceType"],args["precedence"],args["once"],args["delay"],args["rate"],args["adviceMsg"],args["maxCalls"]);
},addAdvice:function(_1ec,_1ed,_1ee,_1ef,_1f0,_1f1,once,_1f3,rate,_1f5,_1f6){
var arr=this.getArr(_1f0);
if(!arr){
dojo.raise("bad this: "+this);
}
var ao=[_1ec,_1ed,_1ee,_1ef,_1f3,rate,_1f5,_1f6];
if(once){
if(this.hasAdvice(_1ec,_1ed,_1f0,arr)>=0){
return;
}
}
if(_1f1=="first"){
arr.unshift(ao);
}else{
arr.push(ao);
}
},hasAdvice:function(_1f9,_1fa,_1fb,arr){
if(!arr){
arr=this.getArr(_1fb);
}
var ind=-1;
for(var x=0;x<arr.length;x++){
var aao=(typeof _1fa=="object")?(new String(_1fa)).toString():_1fa;
var a1o=(typeof arr[x][1]=="object")?(new String(arr[x][1])).toString():arr[x][1];
if((arr[x][0]==_1f9)&&(a1o==aao)){
ind=x;
}
}
return ind;
},removeAdvice:function(_201,_202,_203,once){
var arr=this.getArr(_203);
var ind=this.hasAdvice(_201,_202,_203,arr);
if(ind==-1){
return false;
}
while(ind!=-1){
arr.splice(ind,1);
if(once){
break;
}
ind=this.hasAdvice(_201,_202,_203,arr);
}
return true;
}});
dojo.provide("dojo.event.topic");
dojo.event.topic=new function(){
this.topics={};
this.getTopic=function(_207){
if(!this.topics[_207]){
this.topics[_207]=new this.TopicImpl(_207);
}
return this.topics[_207];
};
this.registerPublisher=function(_208,obj,_20a){
var _208=this.getTopic(_208);
_208.registerPublisher(obj,_20a);
};
this.subscribe=function(_20b,obj,_20d){
var _20b=this.getTopic(_20b);
_20b.subscribe(obj,_20d);
};
this.unsubscribe=function(_20e,obj,_210){
var _20e=this.getTopic(_20e);
_20e.unsubscribe(obj,_210);
};
this.destroy=function(_211){
this.getTopic(_211).destroy();
delete this.topics[_211];
};
this.publishApply=function(_212,args){
var _212=this.getTopic(_212);
_212.sendMessage.apply(_212,args);
};
this.publish=function(_214,_215){
var _214=this.getTopic(_214);
var args=[];
for(var x=1;x<arguments.length;x++){
args.push(arguments[x]);
}
_214.sendMessage.apply(_214,args);
};
};
dojo.event.topic.TopicImpl=function(_218){
this.topicName=_218;
this.subscribe=function(_219,_21a){
var tf=_21a||_219;
var to=(!_21a)?dj_global:_219;
return dojo.event.kwConnect({srcObj:this,srcFunc:"sendMessage",adviceObj:to,adviceFunc:tf});
};
this.unsubscribe=function(_21d,_21e){
var tf=(!_21e)?_21d:_21e;
var to=(!_21e)?null:_21d;
return dojo.event.kwDisconnect({srcObj:this,srcFunc:"sendMessage",adviceObj:to,adviceFunc:tf});
};
this._getJoinPoint=function(){
return dojo.event.MethodJoinPoint.getForMethod(this,"sendMessage");
};
this.setSquelch=function(_221){
this._getJoinPoint().squelch=_221;
};
this.destroy=function(){
this._getJoinPoint().disconnect();
};
this.registerPublisher=function(_222,_223){
dojo.event.connect(_222,_223,this,"sendMessage");
};
this.sendMessage=function(_224){
};
};
dojo.provide("dojo.event.browser");
dojo._ie_clobber=new function(){
this.clobberNodes=[];
function nukeProp(node,prop){
try{
node[prop]=null;
}
catch(e){
}
try{
delete node[prop];
}
catch(e){
}
try{
node.removeAttribute(prop);
}
catch(e){
}
}
this.clobber=function(_227){
var na;
var tna;
if(_227){
tna=_227.all||_227.getElementsByTagName("*");
na=[_227];
for(var x=0;x<tna.length;x++){
if(tna[x]["__doClobber__"]){
na.push(tna[x]);
}
}
}else{
try{
window.onload=null;
}
catch(e){
}
na=(this.clobberNodes.length)?this.clobberNodes:document.all;
}
tna=null;
var _22b={};
for(var i=na.length-1;i>=0;i=i-1){
var el=na[i];
try{
if(el&&el["__clobberAttrs__"]){
for(var j=0;j<el.__clobberAttrs__.length;j++){
nukeProp(el,el.__clobberAttrs__[j]);
}
nukeProp(el,"__clobberAttrs__");
nukeProp(el,"__doClobber__");
}
}
catch(e){
}
}
na=null;
};
};
if(dojo.render.html.ie){
dojo.addOnUnload(function(){
dojo._ie_clobber.clobber();
try{
if((dojo["widget"])&&(dojo.widget["manager"])){
dojo.widget.manager.destroyAll();
}
}
catch(e){
}
if(dojo.widget){
for(var name in dojo.widget._templateCache){
if(dojo.widget._templateCache[name].node){
dojo.dom.destroyNode(dojo.widget._templateCache[name].node);
dojo.widget._templateCache[name].node=null;
delete dojo.widget._templateCache[name].node;
}
}
}
try{
window.onload=null;
}
catch(e){
}
try{
window.onunload=null;
}
catch(e){
}
dojo._ie_clobber.clobberNodes=[];
});
}
dojo.event.browser=new function(){
var _230=0;
this.normalizedEventName=function(_231){
switch(_231){
case "CheckboxStateChange":
case "DOMAttrModified":
case "DOMMenuItemActive":
case "DOMMenuItemInactive":
case "DOMMouseScroll":
case "DOMNodeInserted":
case "DOMNodeRemoved":
case "RadioStateChange":
return _231;
break;
default:
var lcn=_231.toLowerCase();
return (lcn.indexOf("on")==0)?lcn.substr(2):lcn;
break;
}
};
this.clean=function(node){
if(dojo.render.html.ie){
dojo._ie_clobber.clobber(node);
}
};
this.addClobberNode=function(node){
if(!dojo.render.html.ie){
return;
}
if(!node["__doClobber__"]){
node.__doClobber__=true;
dojo._ie_clobber.clobberNodes.push(node);
node.__clobberAttrs__=[];
}
};
this.addClobberNodeAttrs=function(node,_236){
if(!dojo.render.html.ie){
return;
}
this.addClobberNode(node);
for(var x=0;x<_236.length;x++){
node.__clobberAttrs__.push(_236[x]);
}
};
this.removeListener=function(node,_239,fp,_23b){
if(!_23b){
var _23b=false;
}
_239=dojo.event.browser.normalizedEventName(_239);
if(_239=="key"){
if(dojo.render.html.ie){
this.removeListener(node,"onkeydown",fp,_23b);
}
_239="keypress";
}
if(node.removeEventListener){
node.removeEventListener(_239,fp,_23b);
}
};
this.addListener=function(node,_23d,fp,_23f,_240){
if(!node){
return;
}
if(!_23f){
var _23f=false;
}
_23d=dojo.event.browser.normalizedEventName(_23d);
if(_23d=="key"){
if(dojo.render.html.ie){
this.addListener(node,"onkeydown",fp,_23f,_240);
}
_23d="keypress";
}
if(!_240){
var _241=function(evt){
if(!evt){
evt=window.event;
}
var ret=fp(dojo.event.browser.fixEvent(evt,this));
if(_23f){
dojo.event.browser.stopEvent(evt);
}
return ret;
};
}else{
_241=fp;
}
if(node.addEventListener){
node.addEventListener(_23d,_241,_23f);
return _241;
}else{
_23d="on"+_23d;
if(typeof node[_23d]=="function"){
var _244=node[_23d];
node[_23d]=function(e){
_244(e);
return _241(e);
};
}else{
node[_23d]=_241;
}
if(dojo.render.html.ie){
this.addClobberNodeAttrs(node,[_23d]);
}
return _241;
}
};
this.isEvent=function(obj){
return (typeof obj!="undefined")&&(obj)&&(typeof Event!="undefined")&&(obj.eventPhase);
};
this.currentEvent=null;
this.callListener=function(_247,_248){
if(typeof _247!="function"){
dojo.raise("listener not a function: "+_247);
}
dojo.event.browser.currentEvent.currentTarget=_248;
return _247.call(_248,dojo.event.browser.currentEvent);
};
this._stopPropagation=function(){
dojo.event.browser.currentEvent.cancelBubble=true;
};
this._preventDefault=function(){
dojo.event.browser.currentEvent.returnValue=false;
};
this.keys={KEY_BACKSPACE:8,KEY_TAB:9,KEY_CLEAR:12,KEY_ENTER:13,KEY_SHIFT:16,KEY_CTRL:17,KEY_ALT:18,KEY_PAUSE:19,KEY_CAPS_LOCK:20,KEY_ESCAPE:27,KEY_SPACE:32,KEY_PAGE_UP:33,KEY_PAGE_DOWN:34,KEY_END:35,KEY_HOME:36,KEY_LEFT_ARROW:37,KEY_UP_ARROW:38,KEY_RIGHT_ARROW:39,KEY_DOWN_ARROW:40,KEY_INSERT:45,KEY_DELETE:46,KEY_HELP:47,KEY_LEFT_WINDOW:91,KEY_RIGHT_WINDOW:92,KEY_SELECT:93,KEY_NUMPAD_0:96,KEY_NUMPAD_1:97,KEY_NUMPAD_2:98,KEY_NUMPAD_3:99,KEY_NUMPAD_4:100,KEY_NUMPAD_5:101,KEY_NUMPAD_6:102,KEY_NUMPAD_7:103,KEY_NUMPAD_8:104,KEY_NUMPAD_9:105,KEY_NUMPAD_MULTIPLY:106,KEY_NUMPAD_PLUS:107,KEY_NUMPAD_ENTER:108,KEY_NUMPAD_MINUS:109,KEY_NUMPAD_PERIOD:110,KEY_NUMPAD_DIVIDE:111,KEY_F1:112,KEY_F2:113,KEY_F3:114,KEY_F4:115,KEY_F5:116,KEY_F6:117,KEY_F7:118,KEY_F8:119,KEY_F9:120,KEY_F10:121,KEY_F11:122,KEY_F12:123,KEY_F13:124,KEY_F14:125,KEY_F15:126,KEY_NUM_LOCK:144,KEY_SCROLL_LOCK:145};
this.revKeys=[];
for(var key in this.keys){
this.revKeys[this.keys[key]]=key;
}
this.fixEvent=function(evt,_24b){
if(!evt){
if(window["event"]){
evt=window.event;
}
}
if((evt["type"])&&(evt["type"].indexOf("key")==0)){
evt.keys=this.revKeys;
for(var key in this.keys){
evt[key]=this.keys[key];
}
if(evt["type"]=="keydown"&&dojo.render.html.ie){
switch(evt.keyCode){
case evt.KEY_SHIFT:
case evt.KEY_CTRL:
case evt.KEY_ALT:
case evt.KEY_CAPS_LOCK:
case evt.KEY_LEFT_WINDOW:
case evt.KEY_RIGHT_WINDOW:
case evt.KEY_SELECT:
case evt.KEY_NUM_LOCK:
case evt.KEY_SCROLL_LOCK:
case evt.KEY_NUMPAD_0:
case evt.KEY_NUMPAD_1:
case evt.KEY_NUMPAD_2:
case evt.KEY_NUMPAD_3:
case evt.KEY_NUMPAD_4:
case evt.KEY_NUMPAD_5:
case evt.KEY_NUMPAD_6:
case evt.KEY_NUMPAD_7:
case evt.KEY_NUMPAD_8:
case evt.KEY_NUMPAD_9:
case evt.KEY_NUMPAD_PERIOD:
break;
case evt.KEY_NUMPAD_MULTIPLY:
case evt.KEY_NUMPAD_PLUS:
case evt.KEY_NUMPAD_ENTER:
case evt.KEY_NUMPAD_MINUS:
case evt.KEY_NUMPAD_DIVIDE:
break;
case evt.KEY_PAUSE:
case evt.KEY_TAB:
case evt.KEY_BACKSPACE:
case evt.KEY_ENTER:
case evt.KEY_ESCAPE:
case evt.KEY_PAGE_UP:
case evt.KEY_PAGE_DOWN:
case evt.KEY_END:
case evt.KEY_HOME:
case evt.KEY_LEFT_ARROW:
case evt.KEY_UP_ARROW:
case evt.KEY_RIGHT_ARROW:
case evt.KEY_DOWN_ARROW:
case evt.KEY_INSERT:
case evt.KEY_DELETE:
case evt.KEY_F1:
case evt.KEY_F2:
case evt.KEY_F3:
case evt.KEY_F4:
case evt.KEY_F5:
case evt.KEY_F6:
case evt.KEY_F7:
case evt.KEY_F8:
case evt.KEY_F9:
case evt.KEY_F10:
case evt.KEY_F11:
case evt.KEY_F12:
case evt.KEY_F12:
case evt.KEY_F13:
case evt.KEY_F14:
case evt.KEY_F15:
case evt.KEY_CLEAR:
case evt.KEY_HELP:
evt.key=evt.keyCode;
break;
default:
if(evt.ctrlKey||evt.altKey){
var _24d=evt.keyCode;
if(_24d>=65&&_24d<=90&&evt.shiftKey==false){
_24d+=32;
}
if(_24d>=1&&_24d<=26&&evt.ctrlKey){
_24d+=96;
}
evt.key=String.fromCharCode(_24d);
}
}
}else{
if(evt["type"]=="keypress"){
if(dojo.render.html.opera){
if(evt.which==0){
evt.key=evt.keyCode;
}else{
if(evt.which>0){
switch(evt.which){
case evt.KEY_SHIFT:
case evt.KEY_CTRL:
case evt.KEY_ALT:
case evt.KEY_CAPS_LOCK:
case evt.KEY_NUM_LOCK:
case evt.KEY_SCROLL_LOCK:
break;
case evt.KEY_PAUSE:
case evt.KEY_TAB:
case evt.KEY_BACKSPACE:
case evt.KEY_ENTER:
case evt.KEY_ESCAPE:
evt.key=evt.which;
break;
default:
var _24d=evt.which;
if((evt.ctrlKey||evt.altKey||evt.metaKey)&&(evt.which>=65&&evt.which<=90&&evt.shiftKey==false)){
_24d+=32;
}
evt.key=String.fromCharCode(_24d);
}
}
}
}else{
if(dojo.render.html.ie){
if(!evt.ctrlKey&&!evt.altKey&&evt.keyCode>=evt.KEY_SPACE){
evt.key=String.fromCharCode(evt.keyCode);
}
}else{
if(dojo.render.html.safari){
switch(evt.keyCode){
case 25:
evt.key=evt.KEY_TAB;
evt.shift=true;
break;
case 63232:
evt.key=evt.KEY_UP_ARROW;
break;
case 63233:
evt.key=evt.KEY_DOWN_ARROW;
break;
case 63234:
evt.key=evt.KEY_LEFT_ARROW;
break;
case 63235:
evt.key=evt.KEY_RIGHT_ARROW;
break;
case 63236:
evt.key=evt.KEY_F1;
break;
case 63237:
evt.key=evt.KEY_F2;
break;
case 63238:
evt.key=evt.KEY_F3;
break;
case 63239:
evt.key=evt.KEY_F4;
break;
case 63240:
evt.key=evt.KEY_F5;
break;
case 63241:
evt.key=evt.KEY_F6;
break;
case 63242:
evt.key=evt.KEY_F7;
break;
case 63243:
evt.key=evt.KEY_F8;
break;
case 63244:
evt.key=evt.KEY_F9;
break;
case 63245:
evt.key=evt.KEY_F10;
break;
case 63246:
evt.key=evt.KEY_F11;
break;
case 63247:
evt.key=evt.KEY_F12;
break;
case 63250:
evt.key=evt.KEY_PAUSE;
break;
case 63272:
evt.key=evt.KEY_DELETE;
break;
case 63273:
evt.key=evt.KEY_HOME;
break;
case 63275:
evt.key=evt.KEY_END;
break;
case 63276:
evt.key=evt.KEY_PAGE_UP;
break;
case 63277:
evt.key=evt.KEY_PAGE_DOWN;
break;
case 63302:
evt.key=evt.KEY_INSERT;
break;
case 63248:
case 63249:
case 63289:
break;
default:
evt.key=evt.charCode>=evt.KEY_SPACE?String.fromCharCode(evt.charCode):evt.keyCode;
}
}else{
evt.key=evt.charCode>0?String.fromCharCode(evt.charCode):evt.keyCode;
}
}
}
}
}
}
if(dojo.render.html.ie){
if(!evt.target){
evt.target=evt.srcElement;
}
if(!evt.currentTarget){
evt.currentTarget=(_24b?_24b:evt.srcElement);
}
if(!evt.layerX){
evt.layerX=evt.offsetX;
}
if(!evt.layerY){
evt.layerY=evt.offsetY;
}
var doc=(evt.srcElement&&evt.srcElement.ownerDocument)?evt.srcElement.ownerDocument:document;
var _24f=((dojo.render.html.ie55)||(doc["compatMode"]=="BackCompat"))?doc.body:doc.documentElement;
if(!evt.pageX){
evt.pageX=evt.clientX+(_24f.scrollLeft||0);
}
if(!evt.pageY){
evt.pageY=evt.clientY+(_24f.scrollTop||0);
}
if(evt.type=="mouseover"){
evt.relatedTarget=evt.fromElement;
}
if(evt.type=="mouseout"){
evt.relatedTarget=evt.toElement;
}
this.currentEvent=evt;
evt.callListener=this.callListener;
evt.stopPropagation=this._stopPropagation;
evt.preventDefault=this._preventDefault;
}
return evt;
};
this.stopEvent=function(evt){
if(window.event){
evt.cancelBubble=true;
evt.returnValue=false;
}else{
evt.preventDefault();
evt.stopPropagation();
}
};
};
dojo.kwCompoundRequire({common:["dojo.event.common","dojo.event.topic"],browser:["dojo.event.browser"],dashboard:["dojo.event.browser"]});
dojo.provide("dojo.event.*");
dojo.provide("dojo.string.common");
dojo.string.trim=function(str,wh){
if(!str.replace){
return str;
}
if(!str.length){
return str;
}
var re=(wh>0)?(/^\s+/):(wh<0)?(/\s+$/):(/^\s+|\s+$/g);
return str.replace(re,"");
};
dojo.string.trimStart=function(str){
return dojo.string.trim(str,1);
};
dojo.string.trimEnd=function(str){
return dojo.string.trim(str,-1);
};
dojo.string.repeat=function(str,_257,_258){
var out="";
for(var i=0;i<_257;i++){
out+=str;
if(_258&&i<_257-1){
out+=_258;
}
}
return out;
};
dojo.string.pad=function(str,len,c,dir){
var out=String(str);
if(!c){
c="0";
}
if(!dir){
dir=1;
}
while(out.length<len){
if(dir>0){
out=c+out;
}else{
out+=c;
}
}
return out;
};
dojo.string.padLeft=function(str,len,c){
return dojo.string.pad(str,len,c,1);
};
dojo.string.padRight=function(str,len,c){
return dojo.string.pad(str,len,c,-1);
};
dojo.provide("dojo.string.extras");
dojo.string.substituteParams=function(_266,hash){
var map=(typeof hash=="object")?hash:dojo.lang.toArray(arguments,1);
return _266.replace(/\%\{(\w+)\}/g,function(_269,key){
if(typeof (map[key])!="undefined"&&map[key]!=null){
return map[key];
}
dojo.raise("Substitution not found: "+key);
});
};
dojo.string.capitalize=function(str){
if(!dojo.lang.isString(str)){
return "";
}
if(arguments.length==0){
str=this;
}
var _26c=str.split(" ");
for(var i=0;i<_26c.length;i++){
_26c[i]=_26c[i].charAt(0).toUpperCase()+_26c[i].substring(1);
}
return _26c.join(" ");
};
dojo.string.isBlank=function(str){
if(!dojo.lang.isString(str)){
return true;
}
return (dojo.string.trim(str).length==0);
};
dojo.string.encodeAscii=function(str){
if(!dojo.lang.isString(str)){
return str;
}
var ret="";
var _271=escape(str);
var _272,re=/%u([0-9A-F]{4})/i;
while((_272=_271.match(re))){
var num=Number("0x"+_272[1]);
var _275=escape("&#"+num+";");
ret+=_271.substring(0,_272.index)+_275;
_271=_271.substring(_272.index+_272[0].length);
}
ret+=_271.replace(/\+/g,"%2B");
return ret;
};
dojo.string.escape=function(type,str){
var args=dojo.lang.toArray(arguments,1);
switch(type.toLowerCase()){
case "xml":
case "html":
case "xhtml":
return dojo.string.escapeXml.apply(this,args);
case "sql":
return dojo.string.escapeSql.apply(this,args);
case "regexp":
case "regex":
return dojo.string.escapeRegExp.apply(this,args);
case "javascript":
case "jscript":
case "js":
return dojo.string.escapeJavaScript.apply(this,args);
case "ascii":
return dojo.string.encodeAscii.apply(this,args);
default:
return str;
}
};
dojo.string.escapeXml=function(str,_27a){
str=str.replace(/&/gm,"&amp;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;").replace(/"/gm,"&quot;");
if(!_27a){
str=str.replace(/'/gm,"&#39;");
}
return str;
};
dojo.string.escapeSql=function(str){
return str.replace(/'/gm,"''");
};
dojo.string.escapeRegExp=function(str){
return str.replace(/\\/gm,"\\\\").replace(/([\f\b\n\t\r[\^$|?*+(){}])/gm,"\\$1");
};
dojo.string.escapeJavaScript=function(str){
return str.replace(/(["'\f\b\n\t\r])/gm,"\\$1");
};
dojo.string.escapeString=function(str){
return ("\""+str.replace(/(["\\])/g,"\\$1")+"\"").replace(/[\f]/g,"\\f").replace(/[\b]/g,"\\b").replace(/[\n]/g,"\\n").replace(/[\t]/g,"\\t").replace(/[\r]/g,"\\r");
};
dojo.string.summary=function(str,len){
if(!len||str.length<=len){
return str;
}
return str.substring(0,len).replace(/\.+$/,"")+"...";
};
dojo.string.endsWith=function(str,end,_283){
if(_283){
str=str.toLowerCase();
end=end.toLowerCase();
}
if((str.length-end.length)<0){
return false;
}
return str.lastIndexOf(end)==str.length-end.length;
};
dojo.string.endsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.endsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.startsWith=function(str,_287,_288){
if(_288){
str=str.toLowerCase();
_287=_287.toLowerCase();
}
return str.indexOf(_287)==0;
};
dojo.string.startsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.startsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.has=function(str){
for(var i=1;i<arguments.length;i++){
if(str.indexOf(arguments[i])>-1){
return true;
}
}
return false;
};
dojo.string.normalizeNewlines=function(text,_28e){
if(_28e=="\n"){
text=text.replace(/\r\n/g,"\n");
text=text.replace(/\r/g,"\n");
}else{
if(_28e=="\r"){
text=text.replace(/\r\n/g,"\r");
text=text.replace(/\n/g,"\r");
}else{
text=text.replace(/([^\r])\n/g,"$1\r\n").replace(/\r([^\n])/g,"\r\n$1");
}
}
return text;
};
dojo.string.splitEscaped=function(str,_290){
var _291=[];
for(var i=0,_293=0;i<str.length;i++){
if(str.charAt(i)=="\\"){
i++;
continue;
}
if(str.charAt(i)==_290){
_291.push(str.substring(_293,i));
_293=i+1;
}
}
_291.push(str.substr(_293));
return _291;
};
dojo.provide("dojo.string");
dojo.provide("dojo.io.common");
dojo.io.transports=[];
dojo.io.hdlrFuncNames=["load","error","timeout"];
dojo.io.Request=function(url,_295,_296,_297){
if((arguments.length==1)&&(arguments[0].constructor==Object)){
this.fromKwArgs(arguments[0]);
}else{
this.url=url;
if(_295){
this.mimetype=_295;
}
if(_296){
this.transport=_296;
}
if(arguments.length>=4){
this.changeUrl=_297;
}
}
};
dojo.lang.extend(dojo.io.Request,{url:"",mimetype:"text/plain",method:"GET",content:undefined,transport:undefined,changeUrl:undefined,formNode:undefined,sync:false,bindSuccess:false,useCache:false,preventCache:false,jsonFilter:function(_298){
if((this.mimetype=="text/json-comment-filtered")||(this.mimetype=="application/json-comment-filtered")){
var _299=_298.indexOf("/*");
var _29a=_298.lastIndexOf("*/");
if((_299==-1)||(_29a==-1)){
dojo.debug("your JSON wasn't comment filtered!");
return "";
}
return _298.substring(_299+2,_29a);
}
dojo.debug("please consider using a mimetype of text/json-comment-filtered to avoid potential security issues with JSON endpoints");
return _298;
},load:function(type,data,_29d,_29e){
},error:function(type,_2a0,_2a1,_2a2){
},timeout:function(type,_2a4,_2a5,_2a6){
},handle:function(type,data,_2a9,_2aa){
},timeoutSeconds:0,abort:function(){
},fromKwArgs:function(_2ab){
if(_2ab["url"]){
_2ab.url=_2ab.url.toString();
}
if(_2ab["formNode"]){
_2ab.formNode=dojo.byId(_2ab.formNode);
}
if(!_2ab["method"]&&_2ab["formNode"]&&_2ab["formNode"].method){
_2ab.method=_2ab["formNode"].method;
}
if(!_2ab["handle"]&&_2ab["handler"]){
_2ab.handle=_2ab.handler;
}
if(!_2ab["load"]&&_2ab["loaded"]){
_2ab.load=_2ab.loaded;
}
if(!_2ab["changeUrl"]&&_2ab["changeURL"]){
_2ab.changeUrl=_2ab.changeURL;
}
_2ab.encoding=dojo.lang.firstValued(_2ab["encoding"],djConfig["bindEncoding"],"");
_2ab.sendTransport=dojo.lang.firstValued(_2ab["sendTransport"],djConfig["ioSendTransport"],false);
var _2ac=dojo.lang.isFunction;
for(var x=0;x<dojo.io.hdlrFuncNames.length;x++){
var fn=dojo.io.hdlrFuncNames[x];
if(_2ab[fn]&&_2ac(_2ab[fn])){
continue;
}
if(_2ab["handle"]&&_2ac(_2ab["handle"])){
_2ab[fn]=_2ab.handle;
}
}
dojo.lang.mixin(this,_2ab);
}});
dojo.io.Error=function(msg,type,num){
this.message=msg;
this.type=type||"unknown";
this.number=num||0;
};
dojo.io.transports.addTransport=function(name){
this.push(name);
this[name]=dojo.io[name];
};
dojo.io.bind=function(_2b3){
if(!(_2b3 instanceof dojo.io.Request)){
try{
_2b3=new dojo.io.Request(_2b3);
}
catch(e){
dojo.debug(e);
}
}
var _2b4="";
if(_2b3["transport"]){
_2b4=_2b3["transport"];
if(!this[_2b4]){
dojo.io.sendBindError(_2b3,"No dojo.io.bind() transport with name '"+_2b3["transport"]+"'.");
return _2b3;
}
if(!this[_2b4].canHandle(_2b3)){
dojo.io.sendBindError(_2b3,"dojo.io.bind() transport with name '"+_2b3["transport"]+"' cannot handle this type of request.");
return _2b3;
}
}else{
for(var x=0;x<dojo.io.transports.length;x++){
var tmp=dojo.io.transports[x];
if((this[tmp])&&(this[tmp].canHandle(_2b3))){
_2b4=tmp;
break;
}
}
if(_2b4==""){
dojo.io.sendBindError(_2b3,"None of the loaded transports for dojo.io.bind()"+" can handle the request.");
return _2b3;
}
}
this[_2b4].bind(_2b3);
_2b3.bindSuccess=true;
return _2b3;
};
dojo.io.sendBindError=function(_2b7,_2b8){
if((typeof _2b7.error=="function"||typeof _2b7.handle=="function")&&(typeof setTimeout=="function"||typeof setTimeout=="object")){
var _2b9=new dojo.io.Error(_2b8);
setTimeout(function(){
_2b7[(typeof _2b7.error=="function")?"error":"handle"]("error",_2b9,null,_2b7);
},50);
}else{
dojo.raise(_2b8);
}
};
dojo.io.queueBind=function(_2ba){
if(!(_2ba instanceof dojo.io.Request)){
try{
_2ba=new dojo.io.Request(_2ba);
}
catch(e){
dojo.debug(e);
}
}
var _2bb=_2ba.load;
_2ba.load=function(){
dojo.io._queueBindInFlight=false;
var ret=_2bb.apply(this,arguments);
dojo.io._dispatchNextQueueBind();
return ret;
};
var _2bd=_2ba.error;
_2ba.error=function(){
dojo.io._queueBindInFlight=false;
var ret=_2bd.apply(this,arguments);
dojo.io._dispatchNextQueueBind();
return ret;
};
dojo.io._bindQueue.push(_2ba);
dojo.io._dispatchNextQueueBind();
return _2ba;
};
dojo.io._dispatchNextQueueBind=function(){
if(!dojo.io._queueBindInFlight){
dojo.io._queueBindInFlight=true;
if(dojo.io._bindQueue.length>0){
dojo.io.bind(dojo.io._bindQueue.shift());
}else{
dojo.io._queueBindInFlight=false;
}
}
};
dojo.io._bindQueue=[];
dojo.io._queueBindInFlight=false;
dojo.io.argsFromMap=function(map,_2c0,last){
var enc=/utf/i.test(_2c0||"")?encodeURIComponent:dojo.string.encodeAscii;
var _2c3=[];
var _2c4=new Object();
for(var name in map){
var _2c6=function(elt){
var val=enc(name)+"="+enc(elt);
_2c3[(last==name)?"push":"unshift"](val);
};
if(!_2c4[name]){
var _2c9=map[name];
if(dojo.lang.isArray(_2c9)){
dojo.lang.forEach(_2c9,_2c6);
}else{
_2c6(_2c9);
}
}
}
return _2c3.join("&");
};
dojo.io.setIFrameSrc=function(_2ca,src,_2cc){
try{
var r=dojo.render.html;
if(!_2cc){
if(r.safari){
_2ca.location=src;
}else{
frames[_2ca.name].location=src;
}
}else{
var idoc;
if(r.ie){
idoc=_2ca.contentWindow.document;
}else{
if(r.safari){
idoc=_2ca.document;
}else{
idoc=_2ca.contentWindow;
}
}
if(!idoc){
_2ca.location=src;
return;
}else{
idoc.location.replace(src);
}
}
}
catch(e){
dojo.debug(e);
dojo.debug("setIFrameSrc: "+e);
}
};
dojo.provide("dojo.dom");
dojo.dom.ELEMENT_NODE=1;
dojo.dom.ATTRIBUTE_NODE=2;
dojo.dom.TEXT_NODE=3;
dojo.dom.CDATA_SECTION_NODE=4;
dojo.dom.ENTITY_REFERENCE_NODE=5;
dojo.dom.ENTITY_NODE=6;
dojo.dom.PROCESSING_INSTRUCTION_NODE=7;
dojo.dom.COMMENT_NODE=8;
dojo.dom.DOCUMENT_NODE=9;
dojo.dom.DOCUMENT_TYPE_NODE=10;
dojo.dom.DOCUMENT_FRAGMENT_NODE=11;
dojo.dom.NOTATION_NODE=12;
dojo.dom.dojoml="http://www.dojotoolkit.org/2004/dojoml";
dojo.dom.xmlns={svg:"http://www.w3.org/2000/svg",smil:"http://www.w3.org/2001/SMIL20/",mml:"http://www.w3.org/1998/Math/MathML",cml:"http://www.xml-cml.org",xlink:"http://www.w3.org/1999/xlink",xhtml:"http://www.w3.org/1999/xhtml",xul:"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",xbl:"http://www.mozilla.org/xbl",fo:"http://www.w3.org/1999/XSL/Format",xsl:"http://www.w3.org/1999/XSL/Transform",xslt:"http://www.w3.org/1999/XSL/Transform",xi:"http://www.w3.org/2001/XInclude",xforms:"http://www.w3.org/2002/01/xforms",saxon:"http://icl.com/saxon",xalan:"http://xml.apache.org/xslt",xsd:"http://www.w3.org/2001/XMLSchema",dt:"http://www.w3.org/2001/XMLSchema-datatypes",xsi:"http://www.w3.org/2001/XMLSchema-instance",rdf:"http://www.w3.org/1999/02/22-rdf-syntax-ns#",rdfs:"http://www.w3.org/2000/01/rdf-schema#",dc:"http://purl.org/dc/elements/1.1/",dcq:"http://purl.org/dc/qualifiers/1.0","soap-env":"http://schemas.xmlsoap.org/soap/envelope/",wsdl:"http://schemas.xmlsoap.org/wsdl/",AdobeExtensions:"http://ns.adobe.com/AdobeSVGViewerExtensions/3.0/"};
dojo.dom.isNode=function(wh){
if(typeof Element=="function"){
try{
return wh instanceof Element;
}
catch(e){
}
}else{
return wh&&!isNaN(wh.nodeType);
}
};
dojo.dom.getUniqueId=function(){
var _2d0=dojo.doc();
do{
var id="dj_unique_"+(++arguments.callee._idIncrement);
}while(_2d0.getElementById(id));
return id;
};
dojo.dom.getUniqueId._idIncrement=0;
dojo.dom.firstElement=dojo.dom.getFirstChildElement=function(_2d2,_2d3){
var node=_2d2.firstChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.nextSibling;
}
if(_2d3&&node&&node.tagName&&node.tagName.toLowerCase()!=_2d3.toLowerCase()){
node=dojo.dom.nextElement(node,_2d3);
}
return node;
};
dojo.dom.lastElement=dojo.dom.getLastChildElement=function(_2d5,_2d6){
var node=_2d5.lastChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.previousSibling;
}
if(_2d6&&node&&node.tagName&&node.tagName.toLowerCase()!=_2d6.toLowerCase()){
node=dojo.dom.prevElement(node,_2d6);
}
return node;
};
dojo.dom.nextElement=dojo.dom.getNextSiblingElement=function(node,_2d9){
if(!node){
return null;
}
do{
node=node.nextSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_2d9&&_2d9.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.nextElement(node,_2d9);
}
return node;
};
dojo.dom.prevElement=dojo.dom.getPreviousSiblingElement=function(node,_2db){
if(!node){
return null;
}
if(_2db){
_2db=_2db.toLowerCase();
}
do{
node=node.previousSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_2db&&_2db.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.prevElement(node,_2db);
}
return node;
};
dojo.dom.moveChildren=function(_2dc,_2dd,trim){
var _2df=0;
if(trim){
while(_2dc.hasChildNodes()&&_2dc.firstChild.nodeType==dojo.dom.TEXT_NODE){
_2dc.removeChild(_2dc.firstChild);
}
while(_2dc.hasChildNodes()&&_2dc.lastChild.nodeType==dojo.dom.TEXT_NODE){
_2dc.removeChild(_2dc.lastChild);
}
}
while(_2dc.hasChildNodes()){
_2dd.appendChild(_2dc.firstChild);
_2df++;
}
return _2df;
};
dojo.dom.copyChildren=function(_2e0,_2e1,trim){
var _2e3=_2e0.cloneNode(true);
return this.moveChildren(_2e3,_2e1,trim);
};
dojo.dom.replaceChildren=function(node,_2e5){
var _2e6=[];
if(dojo.render.html.ie){
for(var i=0;i<node.childNodes.length;i++){
_2e6.push(node.childNodes[i]);
}
}
dojo.dom.removeChildren(node);
node.appendChild(_2e5);
for(var i=0;i<_2e6.length;i++){
dojo.dom.destroyNode(_2e6[i]);
}
};
dojo.dom.removeChildren=function(node){
var _2e9=node.childNodes.length;
while(node.hasChildNodes()){
dojo.dom.removeNode(node.firstChild);
}
return _2e9;
};
dojo.dom.replaceNode=function(node,_2eb){
return node.parentNode.replaceChild(_2eb,node);
};
dojo.dom.destroyNode=function(node){
if(node.parentNode){
node=dojo.dom.removeNode(node);
}
if(node.nodeType!=3){
if(dojo.evalObjPath("dojo.event.browser.clean",false)){
dojo.event.browser.clean(node);
}
if(dojo.render.html.ie){
node.outerHTML="";
}
}
};
dojo.dom.removeNode=function(node){
if(node&&node.parentNode){
return node.parentNode.removeChild(node);
}
};
dojo.dom.getAncestors=function(node,_2ef,_2f0){
var _2f1=[];
var _2f2=(_2ef&&(_2ef instanceof Function||typeof _2ef=="function"));
while(node){
if(!_2f2||_2ef(node)){
_2f1.push(node);
}
if(_2f0&&_2f1.length>0){
return _2f1[0];
}
node=node.parentNode;
}
if(_2f0){
return null;
}
return _2f1;
};
dojo.dom.getAncestorsByTag=function(node,tag,_2f5){
tag=tag.toLowerCase();
return dojo.dom.getAncestors(node,function(el){
return ((el.tagName)&&(el.tagName.toLowerCase()==tag));
},_2f5);
};
dojo.dom.getFirstAncestorByTag=function(node,tag){
return dojo.dom.getAncestorsByTag(node,tag,true);
};
dojo.dom.isDescendantOf=function(node,_2fa,_2fb){
if(_2fb&&node){
node=node.parentNode;
}
while(node){
if(node==_2fa){
return true;
}
node=node.parentNode;
}
return false;
};
dojo.dom.innerXML=function(node){
if(node.innerXML){
return node.innerXML;
}else{
if(node.xml){
return node.xml;
}else{
if(typeof XMLSerializer!="undefined"){
return (new XMLSerializer()).serializeToString(node);
}
}
}
};
dojo.dom.createDocument=function(){
var doc=null;
var _2fe=dojo.doc();
if(!dj_undef("ActiveXObject")){
var _2ff=["MSXML2","Microsoft","MSXML","MSXML3"];
for(var i=0;i<_2ff.length;i++){
try{
doc=new ActiveXObject(_2ff[i]+".XMLDOM");
}
catch(e){
}
if(doc){
break;
}
}
}else{
if((_2fe.implementation)&&(_2fe.implementation.createDocument)){
doc=_2fe.implementation.createDocument("","",null);
}
}
return doc;
};
dojo.dom.createDocumentFromText=function(str,_302){
if(!_302){
_302="text/xml";
}
if(!dj_undef("DOMParser")){
var _303=new DOMParser();
return _303.parseFromString(str,_302);
}else{
if(!dj_undef("ActiveXObject")){
var _304=dojo.dom.createDocument();
if(_304){
_304.async=false;
_304.loadXML(str);
return _304;
}else{
dojo.debug("toXml didn't work?");
}
}else{
var _305=dojo.doc();
if(_305.createElement){
var tmp=_305.createElement("xml");
tmp.innerHTML=str;
if(_305.implementation&&_305.implementation.createDocument){
var _307=_305.implementation.createDocument("foo","",null);
for(var i=0;i<tmp.childNodes.length;i++){
_307.importNode(tmp.childNodes.item(i),true);
}
return _307;
}
return ((tmp.document)&&(tmp.document.firstChild?tmp.document.firstChild:tmp));
}
}
}
return null;
};
dojo.dom.prependChild=function(node,_30a){
if(_30a.firstChild){
_30a.insertBefore(node,_30a.firstChild);
}else{
_30a.appendChild(node);
}
return true;
};
dojo.dom.insertBefore=function(node,ref,_30d){
if((_30d!=true)&&(node===ref||node.nextSibling===ref)){
return false;
}
var _30e=ref.parentNode;
_30e.insertBefore(node,ref);
return true;
};
dojo.dom.insertAfter=function(node,ref,_311){
var pn=ref.parentNode;
if(ref==pn.lastChild){
if((_311!=true)&&(node===ref)){
return false;
}
pn.appendChild(node);
}else{
return this.insertBefore(node,ref.nextSibling,_311);
}
return true;
};
dojo.dom.insertAtPosition=function(node,ref,_315){
if((!node)||(!ref)||(!_315)){
return false;
}
switch(_315.toLowerCase()){
case "before":
return dojo.dom.insertBefore(node,ref);
case "after":
return dojo.dom.insertAfter(node,ref);
case "first":
if(ref.firstChild){
return dojo.dom.insertBefore(node,ref.firstChild);
}else{
ref.appendChild(node);
return true;
}
break;
default:
ref.appendChild(node);
return true;
}
};
dojo.dom.insertAtIndex=function(node,_317,_318){
var _319=_317.childNodes;
if(!_319.length||_319.length==_318){
_317.appendChild(node);
return true;
}
if(_318==0){
return dojo.dom.prependChild(node,_317);
}
return dojo.dom.insertAfter(node,_319[_318-1]);
};
dojo.dom.textContent=function(node,text){
if(arguments.length>1){
var _31c=dojo.doc();
dojo.dom.replaceChildren(node,_31c.createTextNode(text));
return text;
}else{
if(node.textContent!=undefined){
return node.textContent;
}
var _31d="";
if(node==null){
return _31d;
}
for(var i=0;i<node.childNodes.length;i++){
switch(node.childNodes[i].nodeType){
case 1:
case 5:
_31d+=dojo.dom.textContent(node.childNodes[i]);
break;
case 3:
case 2:
case 4:
_31d+=node.childNodes[i].nodeValue;
break;
default:
break;
}
}
return _31d;
}
};
dojo.dom.hasParent=function(node){
return Boolean(node&&node.parentNode&&dojo.dom.isNode(node.parentNode));
};
dojo.dom.isTag=function(node){
if(node&&node.tagName){
for(var i=1;i<arguments.length;i++){
if(node.tagName==String(arguments[i])){
return String(arguments[i]);
}
}
}
return "";
};
dojo.dom.setAttributeNS=function(elem,_323,_324,_325){
if(elem==null||((elem==undefined)&&(typeof elem=="undefined"))){
dojo.raise("No element given to dojo.dom.setAttributeNS");
}
if(!((elem.setAttributeNS==undefined)&&(typeof elem.setAttributeNS=="undefined"))){
elem.setAttributeNS(_323,_324,_325);
}else{
var _326=elem.ownerDocument;
var _327=_326.createNode(2,_324,_323);
_327.nodeValue=_325;
elem.setAttributeNode(_327);
}
};
dojo.provide("dojo.undo.browser");
try{
if((!djConfig["preventBackButtonFix"])&&(!dojo.hostenv.post_load_)){
document.write("<iframe style='border: 0px; width: 1px; height: 1px; position: absolute; bottom: 0px; right: 0px; visibility: visible;' name='djhistory' id='djhistory' src='"+(djConfig["dojoIframeHistoryUrl"]||dojo.hostenv.getBaseScriptUri()+"iframe_history.html")+"'></iframe>");
}
}
catch(e){
}
if(dojo.render.html.opera){
dojo.debug("Opera is not supported with dojo.undo.browser, so back/forward detection will not work.");
}
dojo.undo.browser={initialHref:(!dj_undef("window"))?window.location.href:"",initialHash:(!dj_undef("window"))?window.location.hash:"",moveForward:false,historyStack:[],forwardStack:[],historyIframe:null,bookmarkAnchor:null,locationTimer:null,setInitialState:function(args){
this.initialState=this._createState(this.initialHref,args,this.initialHash);
},addToHistory:function(args){
this.forwardStack=[];
var hash=null;
var url=null;
if(!this.historyIframe){
if(djConfig["useXDomain"]&&!djConfig["dojoIframeHistoryUrl"]){
dojo.debug("dojo.undo.browser: When using cross-domain Dojo builds,"+" please save iframe_history.html to your domain and set djConfig.dojoIframeHistoryUrl"+" to the path on your domain to iframe_history.html");
}
this.historyIframe=window.frames["djhistory"];
}
if(!this.bookmarkAnchor){
this.bookmarkAnchor=document.createElement("a");
dojo.body().appendChild(this.bookmarkAnchor);
this.bookmarkAnchor.style.display="none";
}
if(args["changeUrl"]){
hash="#"+((args["changeUrl"]!==true)?args["changeUrl"]:(new Date()).getTime());
if(this.historyStack.length==0&&this.initialState.urlHash==hash){
this.initialState=this._createState(url,args,hash);
return;
}else{
if(this.historyStack.length>0&&this.historyStack[this.historyStack.length-1].urlHash==hash){
this.historyStack[this.historyStack.length-1]=this._createState(url,args,hash);
return;
}
}
this.changingUrl=true;
setTimeout("window.location.href = '"+hash+"'; dojo.undo.browser.changingUrl = false;",1);
this.bookmarkAnchor.href=hash;
if(dojo.render.html.ie){
url=this._loadIframeHistory();
var _32c=args["back"]||args["backButton"]||args["handle"];
var tcb=function(_32e){
if(window.location.hash!=""){
setTimeout("window.location.href = '"+hash+"';",1);
}
_32c.apply(this,[_32e]);
};
if(args["back"]){
args.back=tcb;
}else{
if(args["backButton"]){
args.backButton=tcb;
}else{
if(args["handle"]){
args.handle=tcb;
}
}
}
var _32f=args["forward"]||args["forwardButton"]||args["handle"];
var tfw=function(_331){
if(window.location.hash!=""){
window.location.href=hash;
}
if(_32f){
_32f.apply(this,[_331]);
}
};
if(args["forward"]){
args.forward=tfw;
}else{
if(args["forwardButton"]){
args.forwardButton=tfw;
}else{
if(args["handle"]){
args.handle=tfw;
}
}
}
}else{
if(dojo.render.html.moz){
if(!this.locationTimer){
this.locationTimer=setInterval("dojo.undo.browser.checkLocation();",200);
}
}
}
}else{
url=this._loadIframeHistory();
}
this.historyStack.push(this._createState(url,args,hash));
},checkLocation:function(){
if(!this.changingUrl){
var hsl=this.historyStack.length;
if((window.location.hash==this.initialHash||window.location.href==this.initialHref)&&(hsl==1)){
this.handleBackButton();
return;
}
if(this.forwardStack.length>0){
if(this.forwardStack[this.forwardStack.length-1].urlHash==window.location.hash){
this.handleForwardButton();
return;
}
}
if((hsl>=2)&&(this.historyStack[hsl-2])){
if(this.historyStack[hsl-2].urlHash==window.location.hash){
this.handleBackButton();
return;
}
}
}
},iframeLoaded:function(evt,_334){
if(!dojo.render.html.opera){
var _335=this._getUrlQuery(_334.href);
if(_335==null){
if(this.historyStack.length==1){
this.handleBackButton();
}
return;
}
if(this.moveForward){
this.moveForward=false;
return;
}
if(this.historyStack.length>=2&&_335==this._getUrlQuery(this.historyStack[this.historyStack.length-2].url)){
this.handleBackButton();
}else{
if(this.forwardStack.length>0&&_335==this._getUrlQuery(this.forwardStack[this.forwardStack.length-1].url)){
this.handleForwardButton();
}
}
}
},handleBackButton:function(){
var _336=this.historyStack.pop();
if(!_336){
return;
}
var last=this.historyStack[this.historyStack.length-1];
if(!last&&this.historyStack.length==0){
last=this.initialState;
}
if(last){
if(last.kwArgs["back"]){
last.kwArgs["back"]();
}else{
if(last.kwArgs["backButton"]){
last.kwArgs["backButton"]();
}else{
if(last.kwArgs["handle"]){
last.kwArgs.handle("back");
}
}
}
}
this.forwardStack.push(_336);
},handleForwardButton:function(){
var last=this.forwardStack.pop();
if(!last){
return;
}
if(last.kwArgs["forward"]){
last.kwArgs.forward();
}else{
if(last.kwArgs["forwardButton"]){
last.kwArgs.forwardButton();
}else{
if(last.kwArgs["handle"]){
last.kwArgs.handle("forward");
}
}
}
this.historyStack.push(last);
},_createState:function(url,args,hash){
return {"url":url,"kwArgs":args,"urlHash":hash};
},_getUrlQuery:function(url){
var _33d=url.split("?");
if(_33d.length<2){
return null;
}else{
return _33d[1];
}
},_loadIframeHistory:function(){
var url=(djConfig["dojoIframeHistoryUrl"]||dojo.hostenv.getBaseScriptUri()+"iframe_history.html")+"?"+(new Date()).getTime();
this.moveForward=true;
dojo.io.setIFrameSrc(this.historyIframe,url,false);
return url;
}};
dojo.provide("dojo.io.BrowserIO");
if(!dj_undef("window")){
dojo.io.checkChildrenForFile=function(node){
var _340=false;
var _341=node.getElementsByTagName("input");
dojo.lang.forEach(_341,function(_342){
if(_340){
return;
}
if(_342.getAttribute("type")=="file"){
_340=true;
}
});
return _340;
};
dojo.io.formHasFile=function(_343){
return dojo.io.checkChildrenForFile(_343);
};
dojo.io.updateNode=function(node,_345){
node=dojo.byId(node);
var args=_345;
if(dojo.lang.isString(_345)){
args={url:_345};
}
args.mimetype="text/html";
args.load=function(t,d,e){
while(node.firstChild){
dojo.dom.destroyNode(node.firstChild);
}
node.innerHTML=d;
};
dojo.io.bind(args);
};
dojo.io._getAttribute=function(node,key){
var _34c=node.getAttributeNode(key);
if(_34c){
return _34c.value;
}
return null;
};
dojo.io.formFilter=function(node){
var type=(node.type||"").toLowerCase();
return !node.disabled&&node.name&&!dojo.lang.inArray(["file","submit","image","reset","button"],type);
};
dojo.io.encodeForm=function(_34f,_350,_351){
if((!_34f)||(!_34f.tagName)||(!_34f.tagName.toLowerCase()=="form")){
dojo.raise("Attempted to encode a non-form element.");
}
if(!_351){
_351=dojo.io.formFilter;
}
var enc=/utf/i.test(_350||"")?encodeURIComponent:dojo.string.encodeAscii;
var _353=[];
for(var i=0;i<_34f.elements.length;i++){
var elm=_34f.elements[i];
if(!elm||elm.tagName.toLowerCase()=="fieldset"||!_351(elm)){
continue;
}
var name=enc(elm.name);
var type=elm.type.toLowerCase();
if(type=="select-multiple"){
for(var j=0;j<elm.options.length;j++){
if(elm.options[j].selected){
_353.push(name+"="+enc(elm.options[j].value));
}
}
}else{
if(dojo.lang.inArray(["radio","checkbox"],type)){
if(elm.checked){
_353.push(name+"="+enc(elm.value));
}
}else{
_353.push(name+"="+enc(elm.value));
}
}
}
var _359=_34f.getElementsByTagName("input");
for(var i=0;i<_359.length;i++){
var _35a=_359[i];
if(_35a.type.toLowerCase()=="image"&&_35a.form==_34f&&_351(_35a)){
var name=enc(_35a.name);
_353.push(name+"="+enc(_35a.value));
_353.push(name+".x=0");
_353.push(name+".y=0");
}
}
return _353.join("&")+"&";
};
dojo.io.FormBind=function(args){
this.bindArgs={};
if(args&&args.formNode){
this.init(args);
}else{
if(args){
this.init({formNode:args});
}
}
};
dojo.lang.extend(dojo.io.FormBind,{form:null,bindArgs:null,clickedButton:null,init:function(args){
var form=dojo.byId(args.formNode);
if(!form||!form.tagName||form.tagName.toLowerCase()!="form"){
throw new Error("FormBind: Couldn't apply, invalid form");
}else{
if(this.form==form){
return;
}else{
if(this.form){
throw new Error("FormBind: Already applied to a form");
}
}
}
dojo.lang.mixin(this.bindArgs,args);
this.form=form;
this.connect(form,"onsubmit","submit");
for(var i=0;i<form.elements.length;i++){
var node=form.elements[i];
if(node&&node.type&&dojo.lang.inArray(["submit","button"],node.type.toLowerCase())){
this.connect(node,"onclick","click");
}
}
var _360=form.getElementsByTagName("input");
for(var i=0;i<_360.length;i++){
var _361=_360[i];
if(_361.type.toLowerCase()=="image"&&_361.form==form){
this.connect(_361,"onclick","click");
}
}
},onSubmit:function(form){
return true;
},submit:function(e){
e.preventDefault();
if(this.onSubmit(this.form)){
dojo.io.bind(dojo.lang.mixin(this.bindArgs,{formFilter:dojo.lang.hitch(this,"formFilter")}));
}
},click:function(e){
var node=e.currentTarget;
if(node.disabled){
return;
}
this.clickedButton=node;
},formFilter:function(node){
var type=(node.type||"").toLowerCase();
var _368=false;
if(node.disabled||!node.name){
_368=false;
}else{
if(dojo.lang.inArray(["submit","button","image"],type)){
if(!this.clickedButton){
this.clickedButton=node;
}
_368=node==this.clickedButton;
}else{
_368=!dojo.lang.inArray(["file","submit","reset","button"],type);
}
}
return _368;
},connect:function(_369,_36a,_36b){
if(dojo.evalObjPath("dojo.event.connect")){
dojo.event.connect(_369,_36a,this,_36b);
}else{
var fcn=dojo.lang.hitch(this,_36b);
_369[_36a]=function(e){
if(!e){
e=window.event;
}
if(!e.currentTarget){
e.currentTarget=e.srcElement;
}
if(!e.preventDefault){
e.preventDefault=function(){
window.event.returnValue=false;
};
}
fcn(e);
};
}
}});
dojo.io.XMLHTTPTransport=new function(){
var _36e=this;
var _36f={};
this.useCache=false;
this.preventCache=false;
function getCacheKey(url,_371,_372){
return url+"|"+_371+"|"+_372.toLowerCase();
}
function addToCache(url,_374,_375,http){
_36f[getCacheKey(url,_374,_375)]=http;
}
function getFromCache(url,_378,_379){
return _36f[getCacheKey(url,_378,_379)];
}
this.clearCache=function(){
_36f={};
};
function doLoad(_37a,http,url,_37d,_37e){
if(((http.status>=200)&&(http.status<300))||(http.status==304)||(http.status==1223)||(location.protocol=="file:"&&(http.status==0||http.status==undefined))||(location.protocol=="chrome:"&&(http.status==0||http.status==undefined))){
var ret;
if(_37a.method.toLowerCase()=="head"){
var _380=http.getAllResponseHeaders();
ret={};
ret.toString=function(){
return _380;
};
var _381=_380.split(/[\r\n]+/g);
for(var i=0;i<_381.length;i++){
var pair=_381[i].match(/^([^:]+)\s*:\s*(.+)$/i);
if(pair){
ret[pair[1]]=pair[2];
}
}
}else{
if(_37a.mimetype=="text/javascript"){
try{
ret=dj_eval(http.responseText);
}
catch(e){
dojo.debug(e);
dojo.debug(http.responseText);
ret=null;
}
}else{
if(_37a.mimetype.substr(0,9)=="text/json"||_37a.mimetype.substr(0,16)=="application/json"){
try{
ret=dj_eval("("+_37a.jsonFilter(http.responseText)+")");
}
catch(e){
dojo.debug(e);
dojo.debug(http.responseText);
ret=false;
}
}else{
if((_37a.mimetype=="application/xml")||(_37a.mimetype=="text/xml")){
ret=http.responseXML;
if(!ret||typeof ret=="string"||!http.getResponseHeader("Content-Type")){
ret=dojo.dom.createDocumentFromText(http.responseText);
}
}else{
ret=http.responseText;
}
}
}
}
if(_37e){
addToCache(url,_37d,_37a.method,http);
}
_37a[(typeof _37a.load=="function")?"load":"handle"]("load",ret,http,_37a);
}else{
var _384=new dojo.io.Error("XMLHttpTransport Error: "+http.status+" "+http.statusText);
_37a[(typeof _37a.error=="function")?"error":"handle"]("error",_384,http,_37a);
}
}
function setHeaders(http,_386){
if(_386["headers"]){
for(var _387 in _386["headers"]){
if(_387.toLowerCase()=="content-type"&&!_386["contentType"]){
_386["contentType"]=_386["headers"][_387];
}else{
http.setRequestHeader(_387,_386["headers"][_387]);
}
}
}
}
this.inFlight=[];
this.inFlightTimer=null;
this.startWatchingInFlight=function(){
if(!this.inFlightTimer){
this.inFlightTimer=setTimeout("dojo.io.XMLHTTPTransport.watchInFlight();",10);
}
};
this.watchInFlight=function(){
var now=null;
if(!dojo.hostenv._blockAsync&&!_36e._blockAsync){
for(var x=this.inFlight.length-1;x>=0;x--){
try{
var tif=this.inFlight[x];
if(!tif||tif.http._aborted||!tif.http.readyState){
this.inFlight.splice(x,1);
continue;
}
if(4==tif.http.readyState){
this.inFlight.splice(x,1);
doLoad(tif.req,tif.http,tif.url,tif.query,tif.useCache);
}else{
if(tif.startTime){
if(!now){
now=(new Date()).getTime();
}
if(tif.startTime+(tif.req.timeoutSeconds*1000)<now){
if(typeof tif.http.abort=="function"){
tif.http.abort();
}
this.inFlight.splice(x,1);
tif.req[(typeof tif.req.timeout=="function")?"timeout":"handle"]("timeout",null,tif.http,tif.req);
}
}
}
}
catch(e){
try{
var _38b=new dojo.io.Error("XMLHttpTransport.watchInFlight Error: "+e);
tif.req[(typeof tif.req.error=="function")?"error":"handle"]("error",_38b,tif.http,tif.req);
}
catch(e2){
dojo.debug("XMLHttpTransport error callback failed: "+e2);
}
}
}
}
clearTimeout(this.inFlightTimer);
if(this.inFlight.length==0){
this.inFlightTimer=null;
return;
}
this.inFlightTimer=setTimeout("dojo.io.XMLHTTPTransport.watchInFlight();",10);
};
var _38c=dojo.hostenv.getXmlhttpObject()?true:false;
this.canHandle=function(_38d){
var mlc=_38d["mimetype"].toLowerCase()||"";
return _38c&&((dojo.lang.inArray(["text/plain","text/html","application/xml","text/xml","text/javascript"],mlc))||(mlc.substr(0,9)=="text/json"||mlc.substr(0,16)=="application/json"))&&!(_38d["formNode"]&&dojo.io.formHasFile(_38d["formNode"]));
};
this.multipartBoundary="45309FFF-BD65-4d50-99C9-36986896A96F";
this.bind=function(_38f){
if(!_38f["url"]){
if(!_38f["formNode"]&&(_38f["backButton"]||_38f["back"]||_38f["changeUrl"]||_38f["watchForURL"])&&(!djConfig.preventBackButtonFix)){
dojo.deprecated("Using dojo.io.XMLHTTPTransport.bind() to add to browser history without doing an IO request","Use dojo.undo.browser.addToHistory() instead.","0.4");
dojo.undo.browser.addToHistory(_38f);
return true;
}
}
var url=_38f.url;
var _391="";
if(_38f["formNode"]){
var ta=dojo.io._getAttribute(_38f.formNode,"action");
if((ta)&&(!_38f["url"])){
url=ta;
}
var tp=dojo.io._getAttribute(_38f.formNode,"method");
if((tp)&&(!_38f["method"])){
_38f.method=tp;
}
_391+=dojo.io.encodeForm(_38f.formNode,_38f.encoding,_38f["formFilter"]);
}
if(url.indexOf("#")>-1){
dojo.debug("Warning: dojo.io.bind: stripping hash values from url:",url);
url=url.split("#")[0];
}
if(_38f["file"]){
_38f.method="post";
}
if(!_38f["method"]){
_38f.method="get";
}
if(_38f.method.toLowerCase()=="get"){
_38f.multipart=false;
}else{
if(_38f["file"]){
_38f.multipart=true;
}else{
if(!_38f["multipart"]){
_38f.multipart=false;
}
}
}
if(_38f["backButton"]||_38f["back"]||_38f["changeUrl"]){
dojo.undo.browser.addToHistory(_38f);
}
var _394=_38f["content"]||{};
if(_38f.sendTransport){
_394["dojo.transport"]="xmlhttp";
}
do{
if(_38f.postContent){
_391=_38f.postContent;
break;
}
if(_394){
_391+=dojo.io.argsFromMap(_394,_38f.encoding);
}
if(_38f.method.toLowerCase()=="get"||!_38f.multipart){
break;
}
var t=[];
if(_391.length){
var q=_391.split("&");
for(var i=0;i<q.length;++i){
if(q[i].length){
var p=q[i].split("=");
t.push("--"+this.multipartBoundary,"Content-Disposition: form-data; name=\""+p[0]+"\"","",p[1]);
}
}
}
if(_38f.file){
if(dojo.lang.isArray(_38f.file)){
for(var i=0;i<_38f.file.length;++i){
var o=_38f.file[i];
t.push("--"+this.multipartBoundary,"Content-Disposition: form-data; name=\""+o.name+"\"; filename=\""+("fileName" in o?o.fileName:o.name)+"\"","Content-Type: "+("contentType" in o?o.contentType:"application/octet-stream"),"",o.content);
}
}else{
var o=_38f.file;
t.push("--"+this.multipartBoundary,"Content-Disposition: form-data; name=\""+o.name+"\"; filename=\""+("fileName" in o?o.fileName:o.name)+"\"","Content-Type: "+("contentType" in o?o.contentType:"application/octet-stream"),"",o.content);
}
}
if(t.length){
t.push("--"+this.multipartBoundary+"--","");
_391=t.join("\r\n");
}
}while(false);
var _39a=_38f["sync"]?false:true;
var _39b=_38f["preventCache"]||(this.preventCache==true&&_38f["preventCache"]!=false);
var _39c=_38f["useCache"]==true||(this.useCache==true&&_38f["useCache"]!=false);
if(!_39b&&_39c){
var _39d=getFromCache(url,_391,_38f.method);
if(_39d){
doLoad(_38f,_39d,url,_391,false);
return;
}
}
var http=dojo.hostenv.getXmlhttpObject(_38f);
var _39f=false;
if(_39a){
var _3a0=this.inFlight.push({"req":_38f,"http":http,"url":url,"query":_391,"useCache":_39c,"startTime":_38f.timeoutSeconds?(new Date()).getTime():0});
this.startWatchingInFlight();
}else{
_36e._blockAsync=true;
}
if(_38f.method.toLowerCase()=="post"){
if(!_38f.user){
http.open("POST",url,_39a);
}else{
http.open("POST",url,_39a,_38f.user,_38f.password);
}
setHeaders(http,_38f);
http.setRequestHeader("Content-Type",_38f.multipart?("multipart/form-data; boundary="+this.multipartBoundary):(_38f.contentType||"application/x-www-form-urlencoded"));
try{
http.send(_391);
}
catch(e){
if(typeof http.abort=="function"){
http.abort();
}
doLoad(_38f,{status:404},url,_391,_39c);
}
}else{
var _3a1=url;
if(_391!=""){
_3a1+=(_3a1.indexOf("?")>-1?"&":"?")+_391;
}
if(_39b){
_3a1+=(dojo.string.endsWithAny(_3a1,"?","&")?"":(_3a1.indexOf("?")>-1?"&":"?"))+"dojo.preventCache="+new Date().valueOf();
}
if(!_38f.user){
http.open(_38f.method.toUpperCase(),_3a1,_39a);
}else{
http.open(_38f.method.toUpperCase(),_3a1,_39a,_38f.user,_38f.password);
}
setHeaders(http,_38f);
try{
http.send(null);
}
catch(e){
if(typeof http.abort=="function"){
http.abort();
}
doLoad(_38f,{status:404},url,_391,_39c);
}
}
if(!_39a){
doLoad(_38f,http,url,_391,_39c);
_36e._blockAsync=false;
}
_38f.abort=function(){
try{
http._aborted=true;
}
catch(e){
}
return http.abort();
};
return;
};
dojo.io.transports.addTransport("XMLHTTPTransport");
};
}
dojo.provide("dojo.io.cookie");
dojo.io.cookie.setCookie=function(name,_3a3,days,path,_3a6,_3a7){
var _3a8=-1;
if((typeof days=="number")&&(days>=0)){
var d=new Date();
d.setTime(d.getTime()+(days*24*60*60*1000));
_3a8=d.toGMTString();
}
_3a3=escape(_3a3);
document.cookie=name+"="+_3a3+";"+(_3a8!=-1?" expires="+_3a8+";":"")+(path?"path="+path:"")+(_3a6?"; domain="+_3a6:"")+(_3a7?"; secure":"");
};
dojo.io.cookie.set=dojo.io.cookie.setCookie;
dojo.io.cookie.getCookie=function(name){
var idx=document.cookie.lastIndexOf(name+"=");
if(idx==-1){
return null;
}
var _3ac=document.cookie.substring(idx+name.length+1);
var end=_3ac.indexOf(";");
if(end==-1){
end=_3ac.length;
}
_3ac=_3ac.substring(0,end);
_3ac=unescape(_3ac);
return _3ac;
};
dojo.io.cookie.get=dojo.io.cookie.getCookie;
dojo.io.cookie.deleteCookie=function(name){
dojo.io.cookie.setCookie(name,"-",0);
};
dojo.io.cookie.setObjectCookie=function(name,obj,days,path,_3b3,_3b4,_3b5){
if(arguments.length==5){
_3b5=_3b3;
_3b3=null;
_3b4=null;
}
var _3b6=[],_3b7,_3b8="";
if(!_3b5){
_3b7=dojo.io.cookie.getObjectCookie(name);
}
if(days>=0){
if(!_3b7){
_3b7={};
}
for(var prop in obj){
if(obj[prop]==null){
delete _3b7[prop];
}else{
if((typeof obj[prop]=="string")||(typeof obj[prop]=="number")){
_3b7[prop]=obj[prop];
}
}
}
prop=null;
for(var prop in _3b7){
_3b6.push(escape(prop)+"="+escape(_3b7[prop]));
}
_3b8=_3b6.join("&");
}
dojo.io.cookie.setCookie(name,_3b8,days,path,_3b3,_3b4);
};
dojo.io.cookie.getObjectCookie=function(name){
var _3bb=null,_3bc=dojo.io.cookie.getCookie(name);
if(_3bc){
_3bb={};
var _3bd=_3bc.split("&");
for(var i=0;i<_3bd.length;i++){
var pair=_3bd[i].split("=");
var _3c0=pair[1];
if(isNaN(_3c0)){
_3c0=unescape(pair[1]);
}
_3bb[unescape(pair[0])]=_3c0;
}
}
return _3bb;
};
dojo.io.cookie.isSupported=function(){
if(typeof navigator.cookieEnabled!="boolean"){
dojo.io.cookie.setCookie("__TestingYourBrowserForCookieSupport__","CookiesAllowed",90,null);
var _3c1=dojo.io.cookie.getCookie("__TestingYourBrowserForCookieSupport__");
navigator.cookieEnabled=(_3c1=="CookiesAllowed");
if(navigator.cookieEnabled){
this.deleteCookie("__TestingYourBrowserForCookieSupport__");
}
}
return navigator.cookieEnabled;
};
if(!dojo.io.cookies){
dojo.io.cookies=dojo.io.cookie;
}
dojo.kwCompoundRequire({common:["dojo.io.common"],rhino:["dojo.io.RhinoIO"],browser:["dojo.io.BrowserIO","dojo.io.cookie"],dashboard:["dojo.io.BrowserIO","dojo.io.cookie"]});
dojo.provide("dojo.io.*");
dojo.provide("dojo.io");
dojo.deprecated("dojo.io","replaced by dojo.io.*","0.5");
dojo.provide("dojo.AdapterRegistry");
dojo.AdapterRegistry=function(_3c2){
this.pairs=[];
this.returnWrappers=_3c2||false;
};
dojo.lang.extend(dojo.AdapterRegistry,{register:function(name,_3c4,wrap,_3c6,_3c7){
var type=(_3c7)?"unshift":"push";
this.pairs[type]([name,_3c4,wrap,_3c6]);
},match:function(){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[1].apply(this,arguments)){
if((pair[3])||(this.returnWrappers)){
return pair[2];
}else{
return pair[2].apply(this,arguments);
}
}
}
throw new Error("No match found");
},unregister:function(name){
for(var i=0;i<this.pairs.length;i++){
var pair=this.pairs[i];
if(pair[0]==name){
this.pairs.splice(i,1);
return true;
}
}
return false;
}});
dojo.provide("dojo.json");
dojo.json={jsonRegistry:new dojo.AdapterRegistry(),register:function(name,_3cf,wrap,_3d1){
dojo.json.jsonRegistry.register(name,_3cf,wrap,_3d1);
},evalJson:function(json){
try{
return eval("("+json+")");
}
catch(e){
dojo.debug(e);
return json;
}
},serialize:function(o){
var _3d4=typeof (o);
if(_3d4=="undefined"){
return "undefined";
}else{
if((_3d4=="number")||(_3d4=="boolean")){
return o+"";
}else{
if(o===null){
return "null";
}
}
}
if(_3d4=="string"){
return dojo.string.escapeString(o);
}
var me=arguments.callee;
var _3d6;
if(typeof (o.__json__)=="function"){
_3d6=o.__json__();
if(o!==_3d6){
return me(_3d6);
}
}
if(typeof (o.json)=="function"){
_3d6=o.json();
if(o!==_3d6){
return me(_3d6);
}
}
if(_3d4!="function"&&typeof (o.length)=="number"){
var res=[];
for(var i=0;i<o.length;i++){
var val=me(o[i]);
if(typeof (val)!="string"){
val="undefined";
}
res.push(val);
}
return "["+res.join(",")+"]";
}
try{
window.o=o;
_3d6=dojo.json.jsonRegistry.match(o);
return me(_3d6);
}
catch(e){
}
if(_3d4=="function"){
return null;
}
res=[];
for(var k in o){
var _3db;
if(typeof (k)=="number"){
_3db="\""+k+"\"";
}else{
if(typeof (k)=="string"){
_3db=dojo.string.escapeString(k);
}else{
continue;
}
}
val=me(o[k]);
if(typeof (val)!="string"){
continue;
}
res.push(_3db+":"+val);
}
return "{"+res.join(",")+"}";
}};
dojo.provide("dojo.html.common");
dojo.lang.mixin(dojo.html,dojo.dom);
dojo.html.body=function(){
dojo.deprecated("dojo.html.body() moved to dojo.body()","0.5");
return dojo.body();
};
dojo.html.getEventTarget=function(evt){
if(!evt){
evt=dojo.global().event||{};
}
var t=(evt.srcElement?evt.srcElement:(evt.target?evt.target:null));
while((t)&&(t.nodeType!=1)){
t=t.parentNode;
}
return t;
};
dojo.html.getViewport=function(){
var _3de=dojo.global();
var _3df=dojo.doc();
var w=0;
var h=0;
if(dojo.render.html.mozilla){
w=_3df.documentElement.clientWidth;
h=_3de.innerHeight;
}else{
if(!dojo.render.html.opera&&_3de.innerWidth){
w=_3de.innerWidth;
h=_3de.innerHeight;
}else{
if(!dojo.render.html.opera&&dojo.exists(_3df,"documentElement.clientWidth")){
var w2=_3df.documentElement.clientWidth;
if(!w||w2&&w2<w){
w=w2;
}
h=_3df.documentElement.clientHeight;
}else{
if(dojo.body().clientWidth){
w=dojo.body().clientWidth;
h=dojo.body().clientHeight;
}
}
}
}
return {width:w,height:h};
};
dojo.html.getScroll=function(){
var _3e3=dojo.global();
var _3e4=dojo.doc();
var top=_3e3.pageYOffset||_3e4.documentElement.scrollTop||dojo.body().scrollTop||0;
var left=_3e3.pageXOffset||_3e4.documentElement.scrollLeft||dojo.body().scrollLeft||0;
return {top:top,left:left,offset:{x:left,y:top}};
};
dojo.html.getParentByType=function(node,type){
var _3e9=dojo.doc();
var _3ea=dojo.byId(node);
type=type.toLowerCase();
while((_3ea)&&(_3ea.nodeName.toLowerCase()!=type)){
if(_3ea==(_3e9["body"]||_3e9["documentElement"])){
return null;
}
_3ea=_3ea.parentNode;
}
return _3ea;
};
dojo.html.getAttribute=function(node,attr){
node=dojo.byId(node);
if((!node)||(!node.getAttribute)){
return null;
}
var ta=typeof attr=="string"?attr:new String(attr);
var v=node.getAttribute(ta.toUpperCase());
if((v)&&(typeof v=="string")&&(v!="")){
return v;
}
if(v&&v.value){
return v.value;
}
if((node.getAttributeNode)&&(node.getAttributeNode(ta))){
return (node.getAttributeNode(ta)).value;
}else{
if(node.getAttribute(ta)){
return node.getAttribute(ta);
}else{
if(node.getAttribute(ta.toLowerCase())){
return node.getAttribute(ta.toLowerCase());
}
}
}
return null;
};
dojo.html.hasAttribute=function(node,attr){
return dojo.html.getAttribute(dojo.byId(node),attr)?true:false;
};
dojo.html.getCursorPosition=function(e){
e=e||dojo.global().event;
var _3f2={x:0,y:0};
if(e.pageX||e.pageY){
_3f2.x=e.pageX;
_3f2.y=e.pageY;
}else{
var de=dojo.doc().documentElement;
var db=dojo.body();
_3f2.x=e.clientX+((de||db)["scrollLeft"])-((de||db)["clientLeft"]);
_3f2.y=e.clientY+((de||db)["scrollTop"])-((de||db)["clientTop"]);
}
return _3f2;
};
dojo.html.isTag=function(node){
node=dojo.byId(node);
if(node&&node.tagName){
for(var i=1;i<arguments.length;i++){
if(node.tagName.toLowerCase()==String(arguments[i]).toLowerCase()){
return String(arguments[i]).toLowerCase();
}
}
}
return "";
};
if(dojo.render.html.ie&&!dojo.render.html.ie70){
if(window.location.href.substr(0,6).toLowerCase()!="https:"){
(function(){
var _3f7=dojo.doc().createElement("script");
_3f7.src="javascript:'dojo.html.createExternalElement=function(doc, tag){ return doc.createElement(tag); }'";
dojo.doc().getElementsByTagName("head")[0].appendChild(_3f7);
})();
}
}else{
dojo.html.createExternalElement=function(doc,tag){
return doc.createElement(tag);
};
}
dojo.html._callDeprecated=function(_3fa,_3fb,args,_3fd,_3fe){
dojo.deprecated("dojo.html."+_3fa,"replaced by dojo.html."+_3fb+"("+(_3fd?"node, {"+_3fd+": "+_3fd+"}":"")+")"+(_3fe?"."+_3fe:""),"0.5");
var _3ff=[];
if(_3fd){
var _400={};
_400[_3fd]=args[1];
_3ff.push(args[0]);
_3ff.push(_400);
}else{
_3ff=args;
}
var ret=dojo.html[_3fb].apply(dojo.html,args);
if(_3fe){
return ret[_3fe];
}else{
return ret;
}
};
dojo.html.getViewportWidth=function(){
return dojo.html._callDeprecated("getViewportWidth","getViewport",arguments,null,"width");
};
dojo.html.getViewportHeight=function(){
return dojo.html._callDeprecated("getViewportHeight","getViewport",arguments,null,"height");
};
dojo.html.getViewportSize=function(){
return dojo.html._callDeprecated("getViewportSize","getViewport",arguments);
};
dojo.html.getScrollTop=function(){
return dojo.html._callDeprecated("getScrollTop","getScroll",arguments,null,"top");
};
dojo.html.getScrollLeft=function(){
return dojo.html._callDeprecated("getScrollLeft","getScroll",arguments,null,"left");
};
dojo.html.getScrollOffset=function(){
return dojo.html._callDeprecated("getScrollOffset","getScroll",arguments,null,"offset");
};
dojo.provide("dojo.uri.Uri");
dojo.uri=new function(){
this.dojoUri=function(uri){
return new dojo.uri.Uri(dojo.hostenv.getBaseScriptUri(),uri);
};
this.moduleUri=function(_403,uri){
var loc=dojo.hostenv.getModuleSymbols(_403).join("/");
if(!loc){
return null;
}
if(loc.lastIndexOf("/")!=loc.length-1){
loc+="/";
}
var _406=loc.indexOf(":");
var _407=loc.indexOf("/");
if(loc.charAt(0)!="/"&&(_406==-1||_406>_407)){
loc=dojo.hostenv.getBaseScriptUri()+loc;
}
return new dojo.uri.Uri(loc,uri);
};
this.Uri=function(){
var uri=arguments[0];
for(var i=1;i<arguments.length;i++){
if(!arguments[i]){
continue;
}
var _40a=new dojo.uri.Uri(arguments[i].toString());
var _40b=new dojo.uri.Uri(uri.toString());
if((_40a.path=="")&&(_40a.scheme==null)&&(_40a.authority==null)&&(_40a.query==null)){
if(_40a.fragment!=null){
_40b.fragment=_40a.fragment;
}
_40a=_40b;
}else{
if(_40a.scheme==null){
_40a.scheme=_40b.scheme;
if(_40a.authority==null){
_40a.authority=_40b.authority;
if(_40a.path.charAt(0)!="/"){
var path=_40b.path.substring(0,_40b.path.lastIndexOf("/")+1)+_40a.path;
var segs=path.split("/");
for(var j=0;j<segs.length;j++){
if(segs[j]=="."){
if(j==segs.length-1){
segs[j]="";
}else{
segs.splice(j,1);
j--;
}
}else{
if(j>0&&!(j==1&&segs[0]=="")&&segs[j]==".."&&segs[j-1]!=".."){
if(j==segs.length-1){
segs.splice(j,1);
segs[j-1]="";
}else{
segs.splice(j-1,2);
j-=2;
}
}
}
}
_40a.path=segs.join("/");
}
}
}
}
uri="";
if(_40a.scheme!=null){
uri+=_40a.scheme+":";
}
if(_40a.authority!=null){
uri+="//"+_40a.authority;
}
uri+=_40a.path;
if(_40a.query!=null){
uri+="?"+_40a.query;
}
if(_40a.fragment!=null){
uri+="#"+_40a.fragment;
}
}
this.uri=uri.toString();
var _40f="^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?$";
var r=this.uri.match(new RegExp(_40f));
this.scheme=r[2]||(r[1]?"":null);
this.authority=r[4]||(r[3]?"":null);
this.path=r[5];
this.query=r[7]||(r[6]?"":null);
this.fragment=r[9]||(r[8]?"":null);
if(this.authority!=null){
_40f="^((([^:]+:)?([^@]+))@)?([^:]*)(:([0-9]+))?$";
r=this.authority.match(new RegExp(_40f));
this.user=r[3]||null;
this.password=r[4]||null;
this.host=r[5];
this.port=r[7]||null;
}
this.toString=function(){
return this.uri;
};
};
};
dojo.provide("dojo.html.style");
dojo.html.getClass=function(node){
node=dojo.byId(node);
if(!node){
return "";
}
var cs="";
if(typeof node.className=="string"){
cs=node.className;
}else{
if(dojo.html.hasAttribute(node,"class")){
cs=dojo.html.getAttribute(node,"class");
}
}
return cs.replace(/^\s+|\s+$/g,"");
};
dojo.html.getClasses=function(node){
var c=dojo.html.getClass(node);
return (c=="")?[]:c.split(/\s+/g);
};
dojo.html.hasClass=function(node,_416){
return (new RegExp("(^|\\s+)"+_416+"(\\s+|$)")).test(dojo.html.getClass(node));
};
dojo.html.prependClass=function(node,_418){
_418+=" "+dojo.html.getClass(node);
return dojo.html.setClass(node,_418);
};
dojo.html.addClass=function(node,_41a){
if(dojo.html.hasClass(node,_41a)){
return false;
}
_41a=(dojo.html.getClass(node)+" "+_41a).replace(/^\s+|\s+$/g,"");
return dojo.html.setClass(node,_41a);
};
dojo.html.setClass=function(node,_41c){
node=dojo.byId(node);
var cs=new String(_41c);
try{
if(typeof node.className=="string"){
node.className=cs;
}else{
if(node.setAttribute){
node.setAttribute("class",_41c);
try{
node.className=cs;
}
catch(e){
}
}else{
return false;
}
}
}
catch(e){
dojo.debug("dojo.html.setClass() failed",e);
}
return true;
};
dojo.html.removeClass=function(node,_41f,_420){
try{
if(!_420){
var _421=dojo.html.getClass(node).replace(new RegExp("(^|\\s+)"+_41f+"(\\s+|$)"),"$1$2");
}else{
var _421=dojo.html.getClass(node).replace(_41f,"");
}
dojo.html.setClass(node,_421);
}
catch(e){
dojo.debug("dojo.html.removeClass() failed",e);
}
return true;
};
dojo.html.replaceClass=function(node,_423,_424){
dojo.html.removeClass(node,_424);
dojo.html.addClass(node,_423);
};
dojo.html.classMatchType={ContainsAll:0,ContainsAny:1,IsOnly:2};
dojo.html.getElementsByClass=function(_425,_426,_427,_428,_429){
_429=false;
var _42a=dojo.doc();
_426=dojo.byId(_426)||_42a;
var _42b=_425.split(/\s+/g);
var _42c=[];
if(_428!=1&&_428!=2){
_428=0;
}
var _42d=new RegExp("(\\s|^)(("+_42b.join(")|(")+"))(\\s|$)");
var _42e=_42b.join(" ").length;
var _42f=[];
if(!_429&&_42a.evaluate){
var _430=".//"+(_427||"*")+"[contains(";
if(_428!=dojo.html.classMatchType.ContainsAny){
_430+="concat(' ',@class,' '), ' "+_42b.join(" ') and contains(concat(' ',@class,' '), ' ")+" ')";
if(_428==2){
_430+=" and string-length(@class)="+_42e+"]";
}else{
_430+="]";
}
}else{
_430+="concat(' ',@class,' '), ' "+_42b.join(" ') or contains(concat(' ',@class,' '), ' ")+" ')]";
}
var _431=_42a.evaluate(_430,_426,null,XPathResult.ANY_TYPE,null);
var _432=_431.iterateNext();
while(_432){
try{
_42f.push(_432);
_432=_431.iterateNext();
}
catch(e){
break;
}
}
return _42f;
}else{
if(!_427){
_427="*";
}
_42f=_426.getElementsByTagName(_427);
var node,i=0;
outer:
while(node=_42f[i++]){
var _435=dojo.html.getClasses(node);
if(_435.length==0){
continue outer;
}
var _436=0;
for(var j=0;j<_435.length;j++){
if(_42d.test(_435[j])){
if(_428==dojo.html.classMatchType.ContainsAny){
_42c.push(node);
continue outer;
}else{
_436++;
}
}else{
if(_428==dojo.html.classMatchType.IsOnly){
continue outer;
}
}
}
if(_436==_42b.length){
if((_428==dojo.html.classMatchType.IsOnly)&&(_436==_435.length)){
_42c.push(node);
}else{
if(_428==dojo.html.classMatchType.ContainsAll){
_42c.push(node);
}
}
}
}
return _42c;
}
};
dojo.html.getElementsByClassName=dojo.html.getElementsByClass;
dojo.html.toCamelCase=function(_438){
var arr=_438.split("-"),cc=arr[0];
for(var i=1;i<arr.length;i++){
cc+=arr[i].charAt(0).toUpperCase()+arr[i].substring(1);
}
return cc;
};
dojo.html.toSelectorCase=function(_43c){
return _43c.replace(/([A-Z])/g,"-$1").toLowerCase();
};
if(dojo.render.html.ie){
dojo.html.getComputedStyle=function(node,_43e,_43f){
node=dojo.byId(node);
if(!node||!node.currentStyle){
return _43f;
}
return node.currentStyle[dojo.html.toCamelCase(_43e)];
};
dojo.html.getComputedStyles=function(node){
return node.currentStyle;
};
}else{
dojo.html.getComputedStyle=function(node,_442,_443){
node=dojo.byId(node);
if(!node||!node.style){
return _443;
}
var s=document.defaultView.getComputedStyle(node,null);
return (s&&s[dojo.html.toCamelCase(_442)])||"";
};
dojo.html.getComputedStyles=function(node){
return document.defaultView.getComputedStyle(node,null);
};
}
dojo.html.getStyleProperty=function(node,_447){
node=dojo.byId(node);
return (node&&node.style?node.style[dojo.html.toCamelCase(_447)]:undefined);
};
dojo.html.getStyle=function(node,_449){
var _44a=dojo.html.getStyleProperty(node,_449);
return (_44a?_44a:dojo.html.getComputedStyle(node,_449));
};
dojo.html.setStyle=function(node,_44c,_44d){
node=dojo.byId(node);
if(node&&node.style){
var _44e=dojo.html.toCamelCase(_44c);
node.style[_44e]=_44d;
}
};
dojo.html.setStyleText=function(_44f,text){
try{
_44f.style.cssText=text;
}
catch(e){
_44f.setAttribute("style",text);
}
};
dojo.html.copyStyle=function(_451,_452){
if(!_452.style.cssText){
_451.setAttribute("style",_452.getAttribute("style"));
}else{
_451.style.cssText=_452.style.cssText;
}
dojo.html.addClass(_451,dojo.html.getClass(_452));
};
dojo.html.getUnitValue=function(node,_454,_455){
var s=dojo.html.getComputedStyle(node,_454);
if((!s)||((s=="auto")&&(_455))){
return {value:0,units:"px"};
}
var _457=s.match(/(\-?[\d.]+)([a-z%]*)/i);
if(!_457){
return dojo.html.getUnitValue.bad;
}
return {value:Number(_457[1]),units:_457[2].toLowerCase()};
};
dojo.html.getUnitValue.bad={value:NaN,units:""};
if(dojo.render.html.ie){
dojo.html.toPixelValue=function(_458,_459){
if(!_459){
return 0;
}
if(_459.slice(-2)=="px"){
return parseFloat(_459);
}
var _45a=0;
with(_458){
var _45b=style.left;
var _45c=runtimeStyle.left;
runtimeStyle.left=currentStyle.left;
try{
style.left=_459||0;
_45a=style.pixelLeft;
style.left=_45b;
runtimeStyle.left=_45c;
}
catch(e){
}
}
return _45a;
};
}else{
dojo.html.toPixelValue=function(_45d,_45e){
return (_45e&&(_45e.slice(-2)=="px")?parseFloat(_45e):0);
};
}
dojo.html.getPixelValue=function(node,_460,_461){
return dojo.html.toPixelValue(node,dojo.html.getComputedStyle(node,_460));
};
dojo.html.setPositivePixelValue=function(node,_463,_464){
if(isNaN(_464)){
return false;
}
node.style[_463]=Math.max(0,_464)+"px";
return true;
};
dojo.html.styleSheet=null;
dojo.html.insertCssRule=function(_465,_466,_467){
if(!dojo.html.styleSheet){
if(document.createStyleSheet){
dojo.html.styleSheet=document.createStyleSheet();
}else{
if(document.styleSheets[0]){
dojo.html.styleSheet=document.styleSheets[0];
}else{
return null;
}
}
}
if(arguments.length<3){
if(dojo.html.styleSheet.cssRules){
_467=dojo.html.styleSheet.cssRules.length;
}else{
if(dojo.html.styleSheet.rules){
_467=dojo.html.styleSheet.rules.length;
}else{
return null;
}
}
}
if(dojo.html.styleSheet.insertRule){
var rule=_465+" { "+_466+" }";
return dojo.html.styleSheet.insertRule(rule,_467);
}else{
if(dojo.html.styleSheet.addRule){
return dojo.html.styleSheet.addRule(_465,_466,_467);
}else{
return null;
}
}
};
dojo.html.removeCssRule=function(_469){
if(!dojo.html.styleSheet){
dojo.debug("no stylesheet defined for removing rules");
return false;
}
if(dojo.render.html.ie){
if(!_469){
_469=dojo.html.styleSheet.rules.length;
dojo.html.styleSheet.removeRule(_469);
}
}else{
if(document.styleSheets[0]){
if(!_469){
_469=dojo.html.styleSheet.cssRules.length;
}
dojo.html.styleSheet.deleteRule(_469);
}
}
return true;
};
dojo.html._insertedCssFiles=[];
dojo.html.insertCssFile=function(URI,doc,_46c,_46d){
if(!URI){
return;
}
if(!doc){
doc=document;
}
var _46e=dojo.hostenv.getText(URI,false,_46d);
if(_46e===null){
return;
}
_46e=dojo.html.fixPathsInCssText(_46e,URI);
if(_46c){
var idx=-1,node,ent=dojo.html._insertedCssFiles;
for(var i=0;i<ent.length;i++){
if((ent[i].doc==doc)&&(ent[i].cssText==_46e)){
idx=i;
node=ent[i].nodeRef;
break;
}
}
if(node){
var _473=doc.getElementsByTagName("style");
for(var i=0;i<_473.length;i++){
if(_473[i]==node){
return;
}
}
dojo.html._insertedCssFiles.shift(idx,1);
}
}
var _474=dojo.html.insertCssText(_46e,doc);
dojo.html._insertedCssFiles.push({"doc":doc,"cssText":_46e,"nodeRef":_474});
if(_474&&djConfig.isDebug){
_474.setAttribute("dbgHref",URI);
}
return _474;
};
dojo.html.insertCssText=function(_475,doc,URI){
if(!_475){
return;
}
if(!doc){
doc=document;
}
if(URI){
_475=dojo.html.fixPathsInCssText(_475,URI);
}
var _478=doc.createElement("style");
_478.setAttribute("type","text/css");
var head=doc.getElementsByTagName("head")[0];
if(!head){
dojo.debug("No head tag in document, aborting styles");
return;
}else{
head.appendChild(_478);
}
if(_478.styleSheet){
var _47a=function(){
try{
_478.styleSheet.cssText=_475;
}
catch(e){
dojo.debug(e);
}
};
if(_478.styleSheet.disabled){
setTimeout(_47a,10);
}else{
_47a();
}
}else{
var _47b=doc.createTextNode(_475);
_478.appendChild(_47b);
}
return _478;
};
dojo.html.fixPathsInCssText=function(_47c,URI){
if(!_47c||!URI){
return;
}
var _47e,str="",url="",_481="[\\t\\s\\w\\(\\)\\/\\.\\\\'\"-:#=&?~]+";
var _482=new RegExp("url\\(\\s*("+_481+")\\s*\\)");
var _483=/(file|https?|ftps?):\/\//;
regexTrim=new RegExp("^[\\s]*(['\"]?)("+_481+")\\1[\\s]*?$");
if(dojo.render.html.ie55||dojo.render.html.ie60){
var _484=new RegExp("AlphaImageLoader\\((.*)src=['\"]("+_481+")['\"]");
while(_47e=_484.exec(_47c)){
url=_47e[2].replace(regexTrim,"$2");
if(!_483.exec(url)){
url=(new dojo.uri.Uri(URI,url).toString());
}
str+=_47c.substring(0,_47e.index)+"AlphaImageLoader("+_47e[1]+"src='"+url+"'";
_47c=_47c.substr(_47e.index+_47e[0].length);
}
_47c=str+_47c;
str="";
}
while(_47e=_482.exec(_47c)){
url=_47e[1].replace(regexTrim,"$2");
if(!_483.exec(url)){
url=(new dojo.uri.Uri(URI,url).toString());
}
str+=_47c.substring(0,_47e.index)+"url("+url+")";
_47c=_47c.substr(_47e.index+_47e[0].length);
}
return str+_47c;
};
dojo.html.setActiveStyleSheet=function(_485){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("title")){
a.disabled=true;
if(a.getAttribute("title")==_485){
a.disabled=false;
}
}
}
};
dojo.html.getActiveStyleSheet=function(){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("title")&&!a.disabled){
return a.getAttribute("title");
}
}
return null;
};
dojo.html.getPreferredStyleSheet=function(){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("rel").indexOf("alt")==-1&&a.getAttribute("title")){
return a.getAttribute("title");
}
}
return null;
};
dojo.html.applyBrowserClass=function(node){
var drh=dojo.render.html;
var _491={dj_ie:drh.ie,dj_ie55:drh.ie55,dj_ie6:drh.ie60,dj_ie7:drh.ie70,dj_iequirks:drh.ie&&drh.quirks,dj_opera:drh.opera,dj_opera8:drh.opera&&(Math.floor(dojo.render.version)==8),dj_opera9:drh.opera&&(Math.floor(dojo.render.version)==9),dj_khtml:drh.khtml,dj_safari:drh.safari,dj_gecko:drh.mozilla};
for(var p in _491){
if(_491[p]){
dojo.html.addClass(node,p);
}
}
};
dojo.kwCompoundRequire({common:["dojo.html.common","dojo.html.style"]});
dojo.provide("dojo.html.*");
dojo.provide("dojo.html.display");
dojo.html._toggle=function(node,_494,_495){
node=dojo.byId(node);
_495(node,!_494(node));
return _494(node);
};
dojo.html.show=function(node){
node=dojo.byId(node);
if(dojo.html.getStyleProperty(node,"display")=="none"){
dojo.html.setStyle(node,"display",(node.dojoDisplayCache||""));
node.dojoDisplayCache=undefined;
}
};
dojo.html.hide=function(node){
node=dojo.byId(node);
if(typeof node["dojoDisplayCache"]=="undefined"){
var d=dojo.html.getStyleProperty(node,"display");
if(d!="none"){
node.dojoDisplayCache=d;
}
}
dojo.html.setStyle(node,"display","none");
};
dojo.html.setShowing=function(node,_49a){
dojo.html[(_49a?"show":"hide")](node);
};
dojo.html.isShowing=function(node){
return (dojo.html.getStyleProperty(node,"display")!="none");
};
dojo.html.toggleShowing=function(node){
return dojo.html._toggle(node,dojo.html.isShowing,dojo.html.setShowing);
};
dojo.html.displayMap={tr:"",td:"",th:"",img:"inline",span:"inline",input:"inline",button:"inline"};
dojo.html.suggestDisplayByTagName=function(node){
node=dojo.byId(node);
if(node&&node.tagName){
var tag=node.tagName.toLowerCase();
return (tag in dojo.html.displayMap?dojo.html.displayMap[tag]:"block");
}
};
dojo.html.setDisplay=function(node,_4a0){
dojo.html.setStyle(node,"display",((_4a0 instanceof String||typeof _4a0=="string")?_4a0:(_4a0?dojo.html.suggestDisplayByTagName(node):"none")));
};
dojo.html.isDisplayed=function(node){
return (dojo.html.getComputedStyle(node,"display")!="none");
};
dojo.html.toggleDisplay=function(node){
return dojo.html._toggle(node,dojo.html.isDisplayed,dojo.html.setDisplay);
};
dojo.html.setVisibility=function(node,_4a4){
dojo.html.setStyle(node,"visibility",((_4a4 instanceof String||typeof _4a4=="string")?_4a4:(_4a4?"visible":"hidden")));
};
dojo.html.isVisible=function(node){
return (dojo.html.getComputedStyle(node,"visibility")!="hidden");
};
dojo.html.toggleVisibility=function(node){
return dojo.html._toggle(node,dojo.html.isVisible,dojo.html.setVisibility);
};
dojo.html.setOpacity=function(node,_4a8,_4a9){
node=dojo.byId(node);
var h=dojo.render.html;
if(!_4a9){
if(_4a8>=1){
if(h.ie){
dojo.html.clearOpacity(node);
return;
}else{
_4a8=0.999999;
}
}else{
if(_4a8<0){
_4a8=0;
}
}
}
if(h.ie){
if(node.nodeName.toLowerCase()=="tr"){
var tds=node.getElementsByTagName("td");
for(var x=0;x<tds.length;x++){
tds[x].style.filter="Alpha(Opacity="+_4a8*100+")";
}
}
node.style.filter="Alpha(Opacity="+_4a8*100+")";
}else{
if(h.moz){
node.style.opacity=_4a8;
node.style.MozOpacity=_4a8;
}else{
if(h.safari){
node.style.opacity=_4a8;
node.style.KhtmlOpacity=_4a8;
}else{
node.style.opacity=_4a8;
}
}
}
};
dojo.html.clearOpacity=function(node){
node=dojo.byId(node);
var ns=node.style;
var h=dojo.render.html;
if(h.ie){
try{
if(node.filters&&node.filters.alpha){
ns.filter="";
}
}
catch(e){
}
}else{
if(h.moz){
ns.opacity=1;
ns.MozOpacity=1;
}else{
if(h.safari){
ns.opacity=1;
ns.KhtmlOpacity=1;
}else{
ns.opacity=1;
}
}
}
};
dojo.html.getOpacity=function(node){
node=dojo.byId(node);
var h=dojo.render.html;
if(h.ie){
var opac=(node.filters&&node.filters.alpha&&typeof node.filters.alpha.opacity=="number"?node.filters.alpha.opacity:100)/100;
}else{
var opac=node.style.opacity||node.style.MozOpacity||node.style.KhtmlOpacity||1;
}
return opac>=0.999999?1:Number(opac);
};
dojo.provide("dojo.html.layout");
dojo.html.sumAncestorProperties=function(node,prop){
node=(dojo.byId(node)||0).parentNode;
if(!node){
return 0;
}
var _4b5=0;
while(node){
if(dojo.html.getComputedStyle(node,"position")=="fixed"){
return 0;
}
var val=node[prop];
if(val){
_4b5+=val-0;
if(node==dojo.body()){
break;
}
}
node=node.parentNode;
}
return _4b5;
};
dojo.html.setStyleAttributes=function(node,_4b8){
node=dojo.byId(node);
var _4b9=_4b8.replace(/(;)?\s*$/,"").split(";");
for(var i=0;i<_4b9.length;i++){
var _4bb=_4b9[i].split(":");
var name=_4bb[0].replace(/\s*$/,"").replace(/^\s*/,"").toLowerCase();
var _4bd=_4bb[1].replace(/\s*$/,"").replace(/^\s*/,"");
switch(name){
case "opacity":
dojo.html.setOpacity(node,_4bd);
break;
case "content-height":
dojo.html.setContentBox(node,{height:_4bd});
break;
case "content-width":
dojo.html.setContentBox(node,{width:_4bd});
break;
case "outer-height":
dojo.html.setMarginBox(node,{height:_4bd});
break;
case "outer-width":
dojo.html.setMarginBox(node,{width:_4bd});
break;
default:
node.style[dojo.html.toCamelCase(name)]=_4bd;
}
}
};
dojo.html.boxSizing={MARGIN_BOX:"margin-box",BORDER_BOX:"border-box",PADDING_BOX:"padding-box",CONTENT_BOX:"content-box"};
dojo.html.getAbsolutePosition=dojo.html.abs=function(node,_4bf,_4c0){
node=dojo.byId(node,node.ownerDocument);
var ret={x:0,y:0};
var bs=dojo.html.boxSizing;
if(!_4c0){
_4c0=bs.CONTENT_BOX;
}
var _4c3=2;
var _4c4;
switch(_4c0){
case bs.MARGIN_BOX:
_4c4=3;
break;
case bs.BORDER_BOX:
_4c4=2;
break;
case bs.PADDING_BOX:
default:
_4c4=1;
break;
case bs.CONTENT_BOX:
_4c4=0;
break;
}
var h=dojo.render.html;
var db=document["body"]||document["documentElement"];
if(h.ie){
with(node.getBoundingClientRect()){
ret.x=left-2;
ret.y=top-2;
}
}else{
if(document.getBoxObjectFor){
_4c3=1;
try{
var bo=document.getBoxObjectFor(node);
ret.x=bo.x-dojo.html.sumAncestorProperties(node,"scrollLeft");
ret.y=bo.y-dojo.html.sumAncestorProperties(node,"scrollTop");
}
catch(e){
}
}else{
if(node["offsetParent"]){
var _4c8;
if((h.safari)&&(node.style.getPropertyValue("position")=="absolute")&&(node.parentNode==db)){
_4c8=db;
}else{
_4c8=db.parentNode;
}
if(node.parentNode!=db){
var nd=node;
if(dojo.render.html.opera){
nd=db;
}
ret.x-=dojo.html.sumAncestorProperties(nd,"scrollLeft");
ret.y-=dojo.html.sumAncestorProperties(nd,"scrollTop");
}
var _4ca=node;
do{
var n=_4ca["offsetLeft"];
if(!h.opera||n>0){
ret.x+=isNaN(n)?0:n;
}
var m=_4ca["offsetTop"];
ret.y+=isNaN(m)?0:m;
_4ca=_4ca.offsetParent;
}while((_4ca!=_4c8)&&(_4ca!=null));
}else{
if(node["x"]&&node["y"]){
ret.x+=isNaN(node.x)?0:node.x;
ret.y+=isNaN(node.y)?0:node.y;
}
}
}
}
if(_4bf){
var _4cd=dojo.html.getScroll();
ret.y+=_4cd.top;
ret.x+=_4cd.left;
}
var _4ce=[dojo.html.getPaddingExtent,dojo.html.getBorderExtent,dojo.html.getMarginExtent];
if(_4c3>_4c4){
for(var i=_4c4;i<_4c3;++i){
ret.y+=_4ce[i](node,"top");
ret.x+=_4ce[i](node,"left");
}
}else{
if(_4c3<_4c4){
for(var i=_4c4;i>_4c3;--i){
ret.y-=_4ce[i-1](node,"top");
ret.x-=_4ce[i-1](node,"left");
}
}
}
ret.top=ret.y;
ret.left=ret.x;
return ret;
};
dojo.html.isPositionAbsolute=function(node){
return (dojo.html.getComputedStyle(node,"position")=="absolute");
};
dojo.html._sumPixelValues=function(node,_4d2,_4d3){
var _4d4=0;
for(var x=0;x<_4d2.length;x++){
_4d4+=dojo.html.getPixelValue(node,_4d2[x],_4d3);
}
return _4d4;
};
dojo.html.getMargin=function(node){
return {width:dojo.html._sumPixelValues(node,["margin-left","margin-right"],(dojo.html.getComputedStyle(node,"position")=="absolute")),height:dojo.html._sumPixelValues(node,["margin-top","margin-bottom"],(dojo.html.getComputedStyle(node,"position")=="absolute"))};
};
dojo.html.getBorder=function(node){
return {width:dojo.html.getBorderExtent(node,"left")+dojo.html.getBorderExtent(node,"right"),height:dojo.html.getBorderExtent(node,"top")+dojo.html.getBorderExtent(node,"bottom")};
};
dojo.html.getBorderExtent=function(node,side){
return (dojo.html.getStyle(node,"border-"+side+"-style")=="none"?0:dojo.html.getPixelValue(node,"border-"+side+"-width"));
};
dojo.html.getMarginExtent=function(node,side){
return dojo.html._sumPixelValues(node,["margin-"+side],dojo.html.isPositionAbsolute(node));
};
dojo.html.getPaddingExtent=function(node,side){
return dojo.html._sumPixelValues(node,["padding-"+side],true);
};
dojo.html.getPadding=function(node){
return {width:dojo.html._sumPixelValues(node,["padding-left","padding-right"],true),height:dojo.html._sumPixelValues(node,["padding-top","padding-bottom"],true)};
};
dojo.html.getPadBorder=function(node){
var pad=dojo.html.getPadding(node);
var _4e1=dojo.html.getBorder(node);
return {width:pad.width+_4e1.width,height:pad.height+_4e1.height};
};
dojo.html.getBoxSizing=function(node){
var h=dojo.render.html;
var bs=dojo.html.boxSizing;
if(((h.ie)||(h.opera))&&node.nodeName.toLowerCase()!="img"){
var cm=document["compatMode"];
if((cm=="BackCompat")||(cm=="QuirksMode")){
return bs.BORDER_BOX;
}else{
return bs.CONTENT_BOX;
}
}else{
if(arguments.length==0){
node=document.documentElement;
}
var _4e6;
if(!h.ie){
_4e6=dojo.html.getStyle(node,"-moz-box-sizing");
if(!_4e6){
_4e6=dojo.html.getStyle(node,"box-sizing");
}
}
return (_4e6?_4e6:bs.CONTENT_BOX);
}
};
dojo.html.isBorderBox=function(node){
return (dojo.html.getBoxSizing(node)==dojo.html.boxSizing.BORDER_BOX);
};
dojo.html.getBorderBox=function(node){
node=dojo.byId(node);
return {width:node.offsetWidth,height:node.offsetHeight};
};
dojo.html.getPaddingBox=function(node){
var box=dojo.html.getBorderBox(node);
var _4eb=dojo.html.getBorder(node);
return {width:box.width-_4eb.width,height:box.height-_4eb.height};
};
dojo.html.getContentBox=function(node){
node=dojo.byId(node);
var _4ed=dojo.html.getPadBorder(node);
return {width:node.offsetWidth-_4ed.width,height:node.offsetHeight-_4ed.height};
};
dojo.html.setContentBox=function(node,args){
node=dojo.byId(node);
var _4f0=0;
var _4f1=0;
var isbb=dojo.html.isBorderBox(node);
var _4f3=(isbb?dojo.html.getPadBorder(node):{width:0,height:0});
var ret={};
if(typeof args.width!="undefined"){
_4f0=args.width+_4f3.width;
ret.width=dojo.html.setPositivePixelValue(node,"width",_4f0);
}
if(typeof args.height!="undefined"){
_4f1=args.height+_4f3.height;
ret.height=dojo.html.setPositivePixelValue(node,"height",_4f1);
}
return ret;
};
dojo.html.getMarginBox=function(node){
var _4f6=dojo.html.getBorderBox(node);
var _4f7=dojo.html.getMargin(node);
return {width:_4f6.width+_4f7.width,height:_4f6.height+_4f7.height};
};
dojo.html.setMarginBox=function(node,args){
node=dojo.byId(node);
var _4fa=0;
var _4fb=0;
var isbb=dojo.html.isBorderBox(node);
var _4fd=(!isbb?dojo.html.getPadBorder(node):{width:0,height:0});
var _4fe=dojo.html.getMargin(node);
var ret={};
if(typeof args.width!="undefined"){
_4fa=args.width-_4fd.width;
_4fa-=_4fe.width;
ret.width=dojo.html.setPositivePixelValue(node,"width",_4fa);
}
if(typeof args.height!="undefined"){
_4fb=args.height-_4fd.height;
_4fb-=_4fe.height;
ret.height=dojo.html.setPositivePixelValue(node,"height",_4fb);
}
return ret;
};
dojo.html.getElementBox=function(node,type){
var bs=dojo.html.boxSizing;
switch(type){
case bs.MARGIN_BOX:
return dojo.html.getMarginBox(node);
case bs.BORDER_BOX:
return dojo.html.getBorderBox(node);
case bs.PADDING_BOX:
return dojo.html.getPaddingBox(node);
case bs.CONTENT_BOX:
default:
return dojo.html.getContentBox(node);
}
};
dojo.html.toCoordinateObject=dojo.html.toCoordinateArray=function(_503,_504,_505){
if(_503 instanceof Array||typeof _503=="array"){
dojo.deprecated("dojo.html.toCoordinateArray","use dojo.html.toCoordinateObject({left: , top: , width: , height: }) instead","0.5");
while(_503.length<4){
_503.push(0);
}
while(_503.length>4){
_503.pop();
}
var ret={left:_503[0],top:_503[1],width:_503[2],height:_503[3]};
}else{
if(!_503.nodeType&&!(_503 instanceof String||typeof _503=="string")&&("width" in _503||"height" in _503||"left" in _503||"x" in _503||"top" in _503||"y" in _503)){
var ret={left:_503.left||_503.x||0,top:_503.top||_503.y||0,width:_503.width||0,height:_503.height||0};
}else{
var node=dojo.byId(_503);
var pos=dojo.html.abs(node,_504,_505);
var _509=dojo.html.getMarginBox(node);
var ret={left:pos.left,top:pos.top,width:_509.width,height:_509.height};
}
}
ret.x=ret.left;
ret.y=ret.top;
return ret;
};
dojo.html.setMarginBoxWidth=dojo.html.setOuterWidth=function(node,_50b){
return dojo.html._callDeprecated("setMarginBoxWidth","setMarginBox",arguments,"width");
};
dojo.html.setMarginBoxHeight=dojo.html.setOuterHeight=function(){
return dojo.html._callDeprecated("setMarginBoxHeight","setMarginBox",arguments,"height");
};
dojo.html.getMarginBoxWidth=dojo.html.getOuterWidth=function(){
return dojo.html._callDeprecated("getMarginBoxWidth","getMarginBox",arguments,null,"width");
};
dojo.html.getMarginBoxHeight=dojo.html.getOuterHeight=function(){
return dojo.html._callDeprecated("getMarginBoxHeight","getMarginBox",arguments,null,"height");
};
dojo.html.getTotalOffset=function(node,type,_50e){
return dojo.html._callDeprecated("getTotalOffset","getAbsolutePosition",arguments,null,type);
};
dojo.html.getAbsoluteX=function(node,_510){
return dojo.html._callDeprecated("getAbsoluteX","getAbsolutePosition",arguments,null,"x");
};
dojo.html.getAbsoluteY=function(node,_512){
return dojo.html._callDeprecated("getAbsoluteY","getAbsolutePosition",arguments,null,"y");
};
dojo.html.totalOffsetLeft=function(node,_514){
return dojo.html._callDeprecated("totalOffsetLeft","getAbsolutePosition",arguments,null,"left");
};
dojo.html.totalOffsetTop=function(node,_516){
return dojo.html._callDeprecated("totalOffsetTop","getAbsolutePosition",arguments,null,"top");
};
dojo.html.getMarginWidth=function(node){
return dojo.html._callDeprecated("getMarginWidth","getMargin",arguments,null,"width");
};
dojo.html.getMarginHeight=function(node){
return dojo.html._callDeprecated("getMarginHeight","getMargin",arguments,null,"height");
};
dojo.html.getBorderWidth=function(node){
return dojo.html._callDeprecated("getBorderWidth","getBorder",arguments,null,"width");
};
dojo.html.getBorderHeight=function(node){
return dojo.html._callDeprecated("getBorderHeight","getBorder",arguments,null,"height");
};
dojo.html.getPaddingWidth=function(node){
return dojo.html._callDeprecated("getPaddingWidth","getPadding",arguments,null,"width");
};
dojo.html.getPaddingHeight=function(node){
return dojo.html._callDeprecated("getPaddingHeight","getPadding",arguments,null,"height");
};
dojo.html.getPadBorderWidth=function(node){
return dojo.html._callDeprecated("getPadBorderWidth","getPadBorder",arguments,null,"width");
};
dojo.html.getPadBorderHeight=function(node){
return dojo.html._callDeprecated("getPadBorderHeight","getPadBorder",arguments,null,"height");
};
dojo.html.getBorderBoxWidth=dojo.html.getInnerWidth=function(){
return dojo.html._callDeprecated("getBorderBoxWidth","getBorderBox",arguments,null,"width");
};
dojo.html.getBorderBoxHeight=dojo.html.getInnerHeight=function(){
return dojo.html._callDeprecated("getBorderBoxHeight","getBorderBox",arguments,null,"height");
};
dojo.html.getContentBoxWidth=dojo.html.getContentWidth=function(){
return dojo.html._callDeprecated("getContentBoxWidth","getContentBox",arguments,null,"width");
};
dojo.html.getContentBoxHeight=dojo.html.getContentHeight=function(){
return dojo.html._callDeprecated("getContentBoxHeight","getContentBox",arguments,null,"height");
};
dojo.html.setContentBoxWidth=dojo.html.setContentWidth=function(node,_520){
return dojo.html._callDeprecated("setContentBoxWidth","setContentBox",arguments,"width");
};
dojo.html.setContentBoxHeight=dojo.html.setContentHeight=function(node,_522){
return dojo.html._callDeprecated("setContentBoxHeight","setContentBox",arguments,"height");
};
dojo.provide("dojo.html.util");
dojo.html.getElementWindow=function(_523){
return dojo.html.getDocumentWindow(_523.ownerDocument);
};
dojo.html.getDocumentWindow=function(doc){
if(dojo.render.html.safari&&!doc._parentWindow){
var fix=function(win){
win.document._parentWindow=win;
for(var i=0;i<win.frames.length;i++){
fix(win.frames[i]);
}
};
fix(window.top);
}
if(dojo.render.html.ie&&window!==document.parentWindow&&!doc._parentWindow){
doc.parentWindow.execScript("document._parentWindow = window;","Javascript");
var win=doc._parentWindow;
doc._parentWindow=null;
return win;
}
return doc._parentWindow||doc.parentWindow||doc.defaultView;
};
dojo.html.gravity=function(node,e){
node=dojo.byId(node);
var _52b=dojo.html.getCursorPosition(e);
with(dojo.html){
var _52c=getAbsolutePosition(node,true);
var bb=getBorderBox(node);
var _52e=_52c.x+(bb.width/2);
var _52f=_52c.y+(bb.height/2);
}
with(dojo.html.gravity){
return ((_52b.x<_52e?WEST:EAST)|(_52b.y<_52f?NORTH:SOUTH));
}
};
dojo.html.gravity.NORTH=1;
dojo.html.gravity.SOUTH=1<<1;
dojo.html.gravity.EAST=1<<2;
dojo.html.gravity.WEST=1<<3;
dojo.html.overElement=function(_530,e){
_530=dojo.byId(_530);
var _532=dojo.html.getCursorPosition(e);
var bb=dojo.html.getBorderBox(_530);
var _534=dojo.html.getAbsolutePosition(_530,true,dojo.html.boxSizing.BORDER_BOX);
var top=_534.y;
var _536=top+bb.height;
var left=_534.x;
var _538=left+bb.width;
return (_532.x>=left&&_532.x<=_538&&_532.y>=top&&_532.y<=_536);
};
dojo.html.renderedTextContent=function(node){
node=dojo.byId(node);
var _53a="";
if(node==null){
return _53a;
}
for(var i=0;i<node.childNodes.length;i++){
switch(node.childNodes[i].nodeType){
case 1:
case 5:
var _53c="unknown";
try{
_53c=dojo.html.getStyle(node.childNodes[i],"display");
}
catch(E){
}
switch(_53c){
case "block":
case "list-item":
case "run-in":
case "table":
case "table-row-group":
case "table-header-group":
case "table-footer-group":
case "table-row":
case "table-column-group":
case "table-column":
case "table-cell":
case "table-caption":
_53a+="\n";
_53a+=dojo.html.renderedTextContent(node.childNodes[i]);
_53a+="\n";
break;
case "none":
break;
default:
if(node.childNodes[i].tagName&&node.childNodes[i].tagName.toLowerCase()=="br"){
_53a+="\n";
}else{
_53a+=dojo.html.renderedTextContent(node.childNodes[i]);
}
break;
}
break;
case 3:
case 2:
case 4:
var text=node.childNodes[i].nodeValue;
var _53e="unknown";
try{
_53e=dojo.html.getStyle(node,"text-transform");
}
catch(E){
}
switch(_53e){
case "capitalize":
var _53f=text.split(" ");
for(var i=0;i<_53f.length;i++){
_53f[i]=_53f[i].charAt(0).toUpperCase()+_53f[i].substring(1);
}
text=_53f.join(" ");
break;
case "uppercase":
text=text.toUpperCase();
break;
case "lowercase":
text=text.toLowerCase();
break;
default:
break;
}
switch(_53e){
case "nowrap":
break;
case "pre-wrap":
break;
case "pre-line":
break;
case "pre":
break;
default:
text=text.replace(/\s+/," ");
if(/\s$/.test(_53a)){
text.replace(/^\s/,"");
}
break;
}
_53a+=text;
break;
default:
break;
}
}
return _53a;
};
dojo.html.createNodesFromText=function(txt,trim){
if(trim){
txt=txt.replace(/^\s+|\s+$/g,"");
}
var tn=dojo.doc().createElement("div");
tn.style.visibility="hidden";
dojo.body().appendChild(tn);
var _543="none";
if((/^<t[dh][\s\r\n>]/i).test(txt.replace(/^\s+/))){
txt="<table><tbody><tr>"+txt+"</tr></tbody></table>";
_543="cell";
}else{
if((/^<tr[\s\r\n>]/i).test(txt.replace(/^\s+/))){
txt="<table><tbody>"+txt+"</tbody></table>";
_543="row";
}else{
if((/^<(thead|tbody|tfoot)[\s\r\n>]/i).test(txt.replace(/^\s+/))){
txt="<table>"+txt+"</table>";
_543="section";
}
}
}
tn.innerHTML=txt;
if(tn["normalize"]){
tn.normalize();
}
var _544=null;
switch(_543){
case "cell":
_544=tn.getElementsByTagName("tr")[0];
break;
case "row":
_544=tn.getElementsByTagName("tbody")[0];
break;
case "section":
_544=tn.getElementsByTagName("table")[0];
break;
default:
_544=tn;
break;
}
var _545=[];
for(var x=0;x<_544.childNodes.length;x++){
_545.push(_544.childNodes[x].cloneNode(true));
}
tn.style.display="none";
dojo.html.destroyNode(tn);
return _545;
};
dojo.html.placeOnScreen=function(node,_548,_549,_54a,_54b,_54c,_54d){
if(_548 instanceof Array||typeof _548=="array"){
_54d=_54c;
_54c=_54b;
_54b=_54a;
_54a=_549;
_549=_548[1];
_548=_548[0];
}
if(_54c instanceof String||typeof _54c=="string"){
_54c=_54c.split(",");
}
if(!isNaN(_54a)){
_54a=[Number(_54a),Number(_54a)];
}else{
if(!(_54a instanceof Array||typeof _54a=="array")){
_54a=[0,0];
}
}
var _54e=dojo.html.getScroll().offset;
var view=dojo.html.getViewport();
node=dojo.byId(node);
var _550=node.style.display;
node.style.display="";
var bb=dojo.html.getBorderBox(node);
var w=bb.width;
var h=bb.height;
node.style.display=_550;
if(!(_54c instanceof Array||typeof _54c=="array")){
_54c=["TL"];
}
var _554,_555,_556=Infinity,_557;
for(var _558=0;_558<_54c.length;++_558){
var _559=_54c[_558];
var _55a=true;
var tryX=_548-(_559.charAt(1)=="L"?0:w)+_54a[0]*(_559.charAt(1)=="L"?1:-1);
var tryY=_549-(_559.charAt(0)=="T"?0:h)+_54a[1]*(_559.charAt(0)=="T"?1:-1);
if(_54b){
tryX-=_54e.x;
tryY-=_54e.y;
}
if(tryX<0){
tryX=0;
_55a=false;
}
if(tryY<0){
tryY=0;
_55a=false;
}
var x=tryX+w;
if(x>view.width){
x=view.width-w;
_55a=false;
}else{
x=tryX;
}
x=Math.max(_54a[0],x)+_54e.x;
var y=tryY+h;
if(y>view.height){
y=view.height-h;
_55a=false;
}else{
y=tryY;
}
y=Math.max(_54a[1],y)+_54e.y;
if(_55a){
_554=x;
_555=y;
_556=0;
_557=_559;
break;
}else{
var dist=Math.pow(x-tryX-_54e.x,2)+Math.pow(y-tryY-_54e.y,2);
if(_556>dist){
_556=dist;
_554=x;
_555=y;
_557=_559;
}
}
}
if(!_54d){
node.style.left=_554+"px";
node.style.top=_555+"px";
}
return {left:_554,top:_555,x:_554,y:_555,dist:_556,corner:_557};
};
dojo.html.placeOnScreenPoint=function(node,_561,_562,_563,_564){
dojo.deprecated("dojo.html.placeOnScreenPoint","use dojo.html.placeOnScreen() instead","0.5");
return dojo.html.placeOnScreen(node,_561,_562,_563,_564,["TL","TR","BL","BR"]);
};
dojo.html.placeOnScreenAroundElement=function(node,_566,_567,_568,_569,_56a){
var best,_56c=Infinity;
_566=dojo.byId(_566);
var _56d=_566.style.display;
_566.style.display="";
var mb=dojo.html.getElementBox(_566,_568);
var _56f=mb.width;
var _570=mb.height;
var _571=dojo.html.getAbsolutePosition(_566,true,_568);
_566.style.display=_56d;
for(var _572 in _569){
var pos,_574,_575;
var _576=_569[_572];
_574=_571.x+(_572.charAt(1)=="L"?0:_56f);
_575=_571.y+(_572.charAt(0)=="T"?0:_570);
pos=dojo.html.placeOnScreen(node,_574,_575,_567,true,_576,true);
if(pos.dist==0){
best=pos;
break;
}else{
if(_56c>pos.dist){
_56c=pos.dist;
best=pos;
}
}
}
if(!_56a){
node.style.left=best.left+"px";
node.style.top=best.top+"px";
}
return best;
};
dojo.html.scrollIntoView=function(node){
if(!node){
return;
}
if(dojo.render.html.ie){
if(dojo.html.getBorderBox(node.parentNode).height<=node.parentNode.scrollHeight){
node.scrollIntoView(false);
}
}else{
if(dojo.render.html.mozilla){
node.scrollIntoView(false);
}else{
var _578=node.parentNode;
var _579=_578.scrollTop+dojo.html.getBorderBox(_578).height;
var _57a=node.offsetTop+dojo.html.getMarginBox(node).height;
if(_579<_57a){
_578.scrollTop+=(_57a-_579);
}else{
if(_578.scrollTop>node.offsetTop){
_578.scrollTop-=(_578.scrollTop-node.offsetTop);
}
}
}
}
};

